
procedure velocity(slimage,emimage)

char slimage{prompt='Slitless spectrum image'}
char emimage{prompt='Emission line image'}
char logfile='velocity.log'{mode='h',prompt='Log file'}
real slz1{mode='h',prompt='Minimum greylevel for slitless image'}
real slz2{mode='h',prompt='Maximum greylevel for slitless image'}
real emz1{mode='h',prompt='Minimum greylevel for emission line image'}
real emz2{mode='h',prompt='Maximum greylevel for emission line image'}
real lambda0=5006.9{mode='h',prompt='Rest wavelength for emission line image'}
int  nadd=3{mode='h', prompt='Number of rows to sum'}
real z1{mode='ql',prompt='Minimum greylevel'}
real z2{mode='ql',prompt='Maximum greylevel'}
real angle{mode='ql', prompt='Angle to rotate emission line image'}
real xfactor{mode='ql', 
	prompt='Factor to magnify emission line image along dispersion'}
real yfactor{mode='ql', 
	prompt='Factor to magnify emission line image along slit'}
int  nsum{mode='ql', prompt='Number of spatial pixels to sum'}
begin

char slimage2, emimage2, emimage3, slslice, emslice, vlabel1
real slpa, empa, slscale1, slscale2, slscale2x, slscale2y, emscale
real angle2, xfactor2, yfactor2, cbox
real emx0, emy0, slx0, sly0, dx0, dy0, sltop, slbot, slright, slleft
real embot, emtop, emright, emleft, slwave
bool redisp, zero

real x1, x2, y1, y2, z3, z1x, z2x, ccc, gdx, gdy, slxx, emxx, emgdx, slgdx
int frame, nplot, ix, iy, jx, jy, ix1, ix2, iy1, iy2, jx1, jx2
int i1, i2, jy1, jy2, igraph, emmin, emmax, slmin, slmax, junk, iii
char ch1, as, infile, slsec, emsec, ns, slunit, plotname
char delstring1, delstring2, emgsec, slgsec
char ext, pixsec, optelem
real xv1, xv2, yv1, yv2

int isl1, isl2, iem1, iem2


# Get type of image and save character string for file extensions.
show imtype | scan (ext)
ext='.'//ext

# Some parameters. nadd is alterable below. cbox is not.
ccc=299792.5
cbox=7

# Query name of slitless and emission line images.
slimage2=slimage
emimage2=emimage
emimage3=emimage2//'.rescale'
delstring1=''
delstring2=''

emtop=0.0
embot=0.0
emright=0.0
emleft=0.0

sltop=0.0
slbot=0.0
emright=0.0
emleft=0.0
	
# declare imfort program as task.
task $velplot = "$/data/cnelson/scripts/slitless2/velplot.e"

# delete old rescaled image and old image "slices".
if(imaccess(emimage3))imdel (emimage3, verify=no)
imdel ('emslice*'//ext, verify=no)
imdel ('slslice*'//ext, verify=no)

# Get PA from ORIENTAT parameter & pixel scales from CD1_1, CD1_2, 
# CD2_1 & CD2_2.

imgets(slimage2, 'ORIENTAT')
slpa=real(imgets.value)
imgets(slimage2, 'CD2_2')
slscale2=3600.0*real(imgets.value)
slscale2x=slscale2
slscale2y=slscale2

imgets(slimage2, 'OPT_ELEM')
if (imgets.value != '0'){
	optelem=imgets.value
	if(optelem == 'G750L'){
		slscale2x=0.0512
		slscale2y=0.0507
	} else if (optelem == 'G430L'){
		slscale2x=0.0512
		slscale2y=0.0507
	} else if (optelem == 'G230L'){
		slscale2x=0.0244
		slscale2y=0.0244
	} else if (optelem == 'G140L'){
		slscale2x=0.0245
		slscale2y=0.0244
	} else if (optelem == 'G750M'){
		slscale2x=0.0555
		slscale2y=0.0507
		print('Warning: Spatial scale along dispersion varies ',
			'with wavelength!')
	} else if (optelem == 'G430M'){
		slscale2x=0.0561
		slscale2y=0.0507
		print('Warning: Spatial scale along dispersion varies ',
			'with wavelength!')
	} else if (optelem == 'G230M'){
		slscale2x=0.0311
		slscale2y=0.0294
		print('Warning: Spatial scale along dispersion varies ',
			'with wavelength!')
	} else if (optelem == 'G140M'){
		slscale2x=0.0311
		slscale2y=0.0294
		print('Warning: Spatial scale along dispersion varies ',
			'with wavelength!')
	}
}

imgets(slimage2, 'CD1_1')
slscale1=real(imgets.value)
imgets(slimage2, 'CRVAL1')
slwave=real(imgets.value)
imgets(slimage2, 'BUNIT')
slunit=imgets.value

print('Slitless spectrum: ',slimage2,'  PA=',real(nint(1000.*slpa))/1000.)
print('      Pixel scale (along dispersion) = ',
	real(nint(100000.*slscale2x))/100000.,'"/pix')
print('      Pixel scale (across dispersion) = ',
	real(nint(100000.*slscale2y))/100000.,'"/pix')
print('      Spectral scale = ',real(nint(100000.*slscale1))/100000.,'A/pix')

imgets(emimage2, 'ORIENTAT')
empa=real(imgets.value)
imgets(emimage2, 'CD1_1')
x1=3600.0*real(imgets.value)
imgets(emimage2, 'CD1_2')
x2=3600.0*real(imgets.value)
imgets(emimage2, 'CD2_1')
y1=3600.0*real(imgets.value)
imgets(emimage2, 'CD2_2')
y2=3600.0*real(imgets.value)

# calculate pixel scale for emission line image.
emscale=(sqrt(x1*x1+x2*x2)+sqrt(y1*y1+y2*y2))*0.5

print('Emission line image: ',emimage2,'  PA=',real(nint(1000.*empa))/1000.)
print('      Scale = ',real(nint(100000.*emscale))/100000.,'"/pix')

# Display images using stretches slz1, slz2, emz1, & emz2.

display (slimage2, 
1, bpmask="BPM", bpdisplay="none", bpcolors="red", overlay="",
ocolors="green", erase=yes, border_erase=no, select_frame=yes, repeat=no,
fill=no, zscale=no, contrast=0.25, zrange=no, zmask="", nsample=1000,
xcenter=0.5, ycenter=0.5, xsize=1., ysize=1., xmag=1., ymag=1., order=0,
z1=slz1, z2=slz2, ztrans="linear", lutfile="")

display (emimage2, 
2, bpmask="BPM", bpdisplay="none", bpcolors="red", overlay="",
ocolors="green", erase=yes, border_erase=no, select_frame=yes, repeat=no,
fill=no, zscale=no, contrast=0.25, zrange=no, zmask="", nsample=1000,
xcenter=0.5, ycenter=0.5, xsize=1., ysize=1., xmag=1., ymag=1., order=0,
z1=emz1, z2=emz2, ztrans="linear", lutfile="")

ch1='x'
redisp=no

zero=no
nplot=0

# Image cursor options. frame is calculated as the one the cursor was in.
while (ch1 != 'q'){
	ns=fscan(imcur, x1, y1, frame, ch1)	
	frame=frame/100
	if(ch1 == 'q'){
		break
        }else if(ch1 == '?'){
	print('c --- cursor position            i --- imexamine task')
	print('m --- magnify                    n --- # spatial pix. to sum')
        print('p --- plot                       r --- rotate')
        print('s --- change stretch             z --- set zero points')
	print('? --- commands                   q --- quit')

	}else if(ch1 == 'c'){

# 	Get cursor x,y and pixel value from image.

	pixsec='['//nint(x1)//':'//nint(x1)//','//nint(y1)//':'//nint(y1)//']'
		if(frame == 1)listpix (slimage2//pixsec)  | scan (z3, z3)
		if(frame == 2)listpix (emimage2//pixsec)  | scan (z3, z3)
		print('X: ',nint(x1),'  Y:',nint(y1),'  Pixel value: ',z3)
	}else if(ch1 == 'n'){
		nadd=nsum
	}else if(ch1 == 'r'){

#		Rotate emission line image. difference in header PA's gives 
#			default value.

		angle=empa-slpa
		angle2=angle
		print('Rotating ...')

		rotate (emimage2, emimage3, angle2, xin=INDEF, yin=INDEF, 
		xout=INDEF, yout=INDEF, ncols=INDEF, nlines=INDEF, 
		interpolant="poly5", boundary="nearest", constant=0.,
		nxblock=512, nyblock=512, verbose=no)
		emimage2=emimage3
		redisp=yes

	}else if(ch1 == 'm'){

#		Use nmagnify task to match pixel spatial scales. Default
#		is calculated from header values.

		xfactor=emscale/slscale2x
		xfactor2=xfactor
		yfactor=emscale/slscale2y
		yfactor2=yfactor
		print('Rescaling ...')

		magnify (emimage2, emimage3, xfactor2, yfactor2, x1=INDEF, 
		x2=INDEF, dx=INDEF, y1=INDEF, y2=INDEF, dy=INDEF, 
		interpolatio="poly5", boundary="constant", constant=0., 
		fluxconserve=yes, logfile="dev$null")

		emimage2=emimage3
		emscale=emscale/xfactor2
		redisp=yes
	}else if(ch1 == 'i'){

#		Enter imexam task. Useful for getting the right stretch, etc.
		imexam(keeplog=yes, logfile="pgvelocity.log")
	}else if(ch1 == 'z'){

#		Set zero point for nuclear offset and velocity zero point. 
#		Use tvmark (with no marking actually done to switch frames
#		automatically.

		if(frame == 1){
			imcntr(slimage2,x1,y1,cboxsize=cbox) | 
				scan(as,as,slx0,as,sly0)
			tvmark(2, '', interactive=no)
			print('Mark emission line cloud center.')
	  		ns=fscan(imcur, x1, y1, frame, as)	
			imcntr(emimage2,x1,y1,cboxsize=cbox) | 
				scan(as,as,emx0,as,emy0)
		}
		if(frame == 2){
			imcntr(emimage2,x1,y1,cboxsize=cbox) | 
				scan(as,as,emx0,as,emy0)
			tvmark(1, '', interactive=no)
			print('Mark slitless image cloud center.')
	  		ns=fscan(imcur, x1, y1, frame, as)	
			imcntr(slimage2,x1,y1,cboxsize=cbox) | 
				scan(as,as,slx0,as,sly0)
		}
		zero=yes
		print('Slitless center: ',slx0,sly0,
			'  Emission line center ',emx0,emy0)

#		calculate differences in zero-points between images.
		dx0=slx0-emx0
		dy0=sly0-emy0

	}else if(ch1 == 'p'){

#		Produce PGPLOT graphs of image slices for comparative analysis.
#		Add up nadd lines in each image to produce 1-D slice image.
# 		delstring is just for latter clean up of slice images. 
# 		Uses my imsize task to get number of columns in images.

		nplot=nplot+1

#		Check that zero points were specified.
		if(zero){
			emslice='emslice'//nplot
			slslice='slslice'//nplot
			plotname='velocity'//nplot
			delstring1=delstring1//','//emslice//ext
			delstring2=delstring2//','//slslice//ext

			iii=abs(int(2.0*(real(nadd)/2.0-real(nadd/2)))-1)
			iy1=nint(y1)-nadd/2
			iy2=nint(y1)+nadd/2-iii

			if(frame==1){
#				jy1=iy1-nint(dy0)
#				jy2=iy2-nint(dy0)
				jy1=iy1-nint(sly0)+nint(emy0)
				jy2=iy2-nint(sly0)+nint(emy0)

				slsec='[*,'//iy1//':'//iy2//']'
				emsec='[*,'//jy1//':'//jy2//']'

				isl1=iy1
				isl2=iy2
				iem1=jy1
				iem2=jy2

			}else if(frame==2){
#				jy1=iy1+nint(dy0)
#				jy2=iy2+nint(dy0)
				jy1=iy1-nint(emy0)+nint(sly0)
				jy2=iy2-nint(emy0)+nint(sly0)
				emsec='[*,'//iy1//':'//iy2//']'
				slsec='[*,'//jy1//':'//jy2//']'

				isl1=jy1
				isl2=jy2
				iem1=iy1
				iem2=iy2
			}

#				print(emsec)
#				print(slsec)
			blkavg (slimage2//slsec, slslice, 1, nadd, 1, 
					1, 1, 1, 1, option="sum")
			blkavg (emimage2//emsec, emslice, 1, nadd, 1, 
					1, 1, 1, 1, option="sum")
			imsize(emslice) | scan(emmax)
			imsize(slslice) | scan(slmax)

#		Imfort programs require .imh type files. So convert if needed.
			if(ext == '.hhh'){
				if(access(slslice//".imh"))
					imdel(slslice//".imh", verify=no)
				if(access(emslice//".imh"))
					imdel(emslice//".imh", verify=no)
				imcopy (slslice//ext, slslice//".imh",
					verbose=yes)
				imcopy (emslice//ext, emslice//".imh",
					verbose=yes)
				if(access(slslice//".hhh"))
					imdel(slslice//".hhh", verify=no)
				if(access(emslice//".imh"))
					imdel(emslice//".hhh", verify=no)
			}			

#			Run Imfort program.

			print('Velplot ...')
			
			velplot(slslice, emslice, slx0, sly0, emx0, emy0, 
				slscale1, lambda0, isl1, isl2, iem1, iem2, 
				plotname, logfile)
		} else {
			beep
			print('Must first initialize zero point.')
		}

	}else if(ch1 == 's'){

#		change stretch.

		if(frame==1){
			z1=slz1
			z2=slz2
			
			z1x=z1
			z2x=z2

			slz1=z1x
			slz2=z2x
			display (slimage2, 1, bpmask="BPM", bpdisplay="none", 
			bpcolors="red", overlay="", ocolors="green", erase=yes, 
			border_erase=no, select_frame=yes, repeat=no, fill=no, 
			zscale=no, contrast=0.25, zrange=no, zmask="", 
			nsample=1000, xcenter=0.5, ycenter=0.5, xsize=1., 
			ysize=1., xmag=1., ymag=1., order=0, z1=z1x, z2=z2x, 
			ztrans="linear",lutfile="")

		} else if(frame==2){

			z1=emz1
			z2=emz2
			z1x=z1
			z2x=z2

			emz1=z1x
			emz2=z2x
			display (emimage2, 2, bpmask="BPM", bpdisplay="none", 
			bpcolors="red", overlay="", ocolors="green", erase=yes, 
			border_erase=no, select_frame=yes, repeat=no, fill=no, 
			zscale=no, contrast=0.25, zrange=no, zmask="", 
			nsample=1000, xcenter=0.5, ycenter=0.5, xsize=1., 
			ysize=1., xmag=1., ymag=1., order=0, z1=z1x, z2=z2x, 
			ztrans="linear",lutfile="")
		}

	}

#	Sometimes want to redisplay emission line image.
	if(redisp) {
		display (emimage2, 2, bpmask="BPM", bpdisplay="none", 
		bpcolors="red", overlay="", ocolors="green", erase=yes, 
		border_erase=no, select_frame=yes, repeat=no, fill=no, 
		zscale=no, contrast=0.25, zrange=no, zmask="", nsample=1000, 
		xcenter=0.5, ycenter=0.5, xsize=1., ysize=1., xmag=1., ymag=1., 
		order=0, z1=emz1, z2=emz2, ztrans="linear", lutfile="")

		redisp=no
	}
}

imdel (delstring1, verify=no)
imdel (delstring2, verify=no)

end

