
      program velplot

C     Compile statement: fc velplot.f /"pgplot-dir"/libpgplot.a -lX11 -lm

      common /gwindow/xmaxy,xminy,ymaxy,yminy,xmaxz,xminz,ymaxz,yminz
      common /gwindow2/yzero,zzero,xwindow,nslpix,nempix
      common /gwindow3/xleft,xright,ytop,ybot,ylen,xlen,xrange,yrange
      common /cursblock/x,y,chopt
      common /options/izero,ireplot,imark,iyscaley,iyscalez,
     +     iprint,ihisto,icont
      common /plotopt/mplot, plotname
      common /centers/slc(9),sly(9),idslc(9),nslc,
     +     emc(9),emy(9),idemc(9),nemc
      common /spect/disp, lambda0
      common /results1/yres1,yres2,zres1,zres2,logfile
      real slpix(2048), empix(2048), lambda0
      character slslice*60, emslice*60, chopt*1, ylab*80, zlab*80
      character logfile*80,yres1*80,yres2*80,zres1*80,zres2*80
      character plotname*12

C     accept command line arguments: image names, zero-points, 
C     spectral dispersion. 

      call clnarg(nargs)
        if(nargs.eq.14)then
           call clargc(1,slslice, ier)
           if(ier.ne.0) goto 100
           call clargc(2,emslice, ier)
           if(ier.ne.0) goto 100
           call clargr(3,slzerox, ier)
           if(ier.ne.0) goto 100
           call clargr(4,slzeroy, ier)
           if(ier.ne.0) goto 100
           call clargr(5,emzerox, ier)
           if(ier.ne.0) goto 100
           call clargr(6,emzeroy, ier)
           if(ier.ne.0) goto 100
           call clargr(7,disp, ier)
           if(ier.ne.0) goto 100
           call clargr(8,lambda0, ier)
           if(ier.ne.0) goto 100
           call clargi(9,isl1, ier)
           if(ier.ne.0) goto 100
           call clargi(10,isl2, ier)
           if(ier.ne.0) goto 100
           call clargi(11,iem1, ier)
           if(ier.ne.0) goto 100
           call clargi(12,iem2, ier)
           if(ier.ne.0) goto 100
           call clargc(13,plotname, ier)
           if(ier.ne.0) goto 100
           call clargc(14,logfile, ier)
           if(ier.ne.0) goto 100
         else
           errmesg=" Error: need 14 command line arguments"
           goto 101
        endif

C       Load images. nslpix is length of slitless spectrum; nempix is length
C       of emission line image.

        call load(slpix,slslice,ix1,ix2,iy1,iy2)
        nslpix=ix2-ix1+1
        call load(empix,emslice,ix1,ix2,iy1,iy2)
        nempix=ix2-ix1+1

C       Initialize PGPLOT

        call pgbegin(0,'2/xserve',1,1) 
        call pgask(.false.)
C     Initialize statusline
        call statusline(text,6,1,1)

C     Set up initial options.

C     For plot axes relative to zero point set izero=1
        izero=1

C     To replot graphs on a given loop set ireplot=1
        ireplot = 1

C     To mark cursor position after a cursor command set imark=1 (overriden
C           by jmark, see below).
        imark=1

C     To automatically set vertical graph window set iyscalez=1 or iyscaley=1.

        iyscalez=1
        iyscaley=1

C     To send plots to PostScript file set iprint=1
        iprint=0

C     To view plots in histogram mode set ihisto=1
        ihisto=0

C     If continuum has been fit icont=1
        icont=0

C     Upper frame is Y & slitless data. Lower frame is Z & emission line image.
        yzero=slzerox
        zzero=emzerox
        
C     Number of emission line and slitless cloud peaks marked.
        nslc=0
        nemc=0

C     Default size of graph window. Could make this changeable.
        xwindow=300
        xminy=-xwindow/2.
        xmaxy=xwindow/2.
        xminz=-xwindow/2.
        xmaxz=xwindow/2.

C     initial cursor position in viewport coordinates.
        x=0.5
        y=0.5

C     Write initial results strings.
        
        jsl1=isl1-nint(slzeroy)
        jsl2=isl2-nint(slzeroy)
        jem1=iem1-nint(emzeroy)
        jem2=iem2-nint(emzeroy)
        write(zres1,'('' Emission Line Image Zero-Point: X0 = '',
     +       f7.2,2x,''Y0 = '',f7.2)')emzerox,emzeroy
        write(yres1,'('' Slitless Spectrum Zero-Point:   X0 = '',
     +       f7.2,2x,''Y0 = '',f7.2)')slzerox,slzeroy
        write(zres2,'('' Emission Line Image Slice: '',i4,'':'',
     +       i4,'' --- '',i4,'':'',i4,3x,''(from Zero-pt.)'')')
     +       iem1, iem2, jem1,jem2
        write(yres2,'('' Slitless Spectrum  Slice:  '',i4,'':'',
     +       i4,'' --- '',i4,'':'',i4,3x,''(from Zero-pt.)'')')
     +       isl1, isl2, jsl1,jsl2

C     loop over these subroutines until quit.
        nplot=0
        do while(chopt.ne.'q'.and.chopt.ne.'Q')
           if(izero.eq.1)then

C     set up top labels for plots.
              jsl1=isl1-nint(slzeroy)
              jsl2=isl2-nint(slzeroy)
              jem1=iem1-nint(emzeroy)
              jem2=iem2-nint(emzeroy)
C              print*,isl1,isl2,jsl1,jsl2,slzeroy
C              print*,iem1,iem2,jem1,jem2,emzeroy

              if(jem1.ne.jem2) write(zlab,'(''Emission Line Image'',
     +             i4,'':'',i4,3x,''(from Zero pt.)'')')jem1,jem2
              if(jem1.eq.jem2) write(zlab,'(''Emission Line Image'',
     +             i4,3x,''(from Zero pt.)'')')jem1
              if(jsl1.ne.jsl2) write(ylab,'(''Slitless Spectrum'',
     +             i4,'':'',i4,3x,''(from Zero pt.)'')')jsl1,jsl2
              if(jsl1.eq.jsl2) write(ylab,'(''Slitless Spectrum'',
     +             i4,3x,''(from Zero pt.)'')')jsl1
           else
              if(iem1.ne.iem2) write(zlab,'(''Emission Line Image'',
     +             i4,'':'',i4)')iem1,iem2
              if(iem1.eq.iem2) write(zlab,'(''Emission Line Image'',
     +             i4)')jem1
              if(isl1.ne.isl2) write(ylab,'(''Slitless Spectrum'',
     +             i4,'':'',i4)')isl1,isl2
              if(isl1.eq.isl2) write(ylab,'(''Slitless Spectrum'',
     +             i4)')isl1
           endif

           if(ireplot.eq.1)call plot(slpix,empix,ylab,zlab)
           call cursopt
        enddo

        call pgend
        stop

 100    call imemsg(ierr, errmsg)

 101    write(*,'('' Error: '',a72)')errmesg
        call pgend
        stop

        end

*******************************************************************************

      SUBROUTINE PLOT(slpix,empix,top1,top2)

      common /gwindow/xmaxy,xminy,ymaxy,yminy,xmaxz,xminz,ymaxz,yminz
      common /gwindow2/yzero,zzero,xwindow,nslpix,nempix
      common /gwindow3/xleft,xright,ytop,ybot,ylen,xlen,xrange,yrange
      common /cursblock/x,y,chopt
      common /options/izero,ireplot,imark,iyscaley,iyscalez,
     +     iprint,ihisto,icont
      common /plotopt/mplot, plotname
      common /contin/conty(4096),contz(4096),nconty,ncontz
      common /plotdata/XXY(4096),XXZ(4096),YY(4096),ZZ(4096)
      common /centers/slc(9),sly(9),idslc(9),nslc,
     +     emc(9),emy(9),idemc(9),nemc
      common /gaussians/slgpar(9,3),islmin(10),islmax(10),nslgfit,
     +     emgpar(9,3),iemmin(10),iemmax(10),nemgfit
      common /profiles/slcpeak(9),slpeak(9),slc80(9),slw80(9),slc50(9),
     +     slw50(9),slc20(9),slw20(9),slczero(9),slwzero(9),slflux(9),
     +     emcpeak(9),empeak(9),emc80(9),emw80(9),emc50(9),emw50(9),
     +     emc20(9),emw20(9),emczero(9),emwzero(9),emflux(9)
      common /spect/disp, lambda0

      character top1*(*),top2*(*),chopt*1,idch*1,plotname*12,text*80
      real slpix(2048),empix(2048), lambda0
      REAL XXY(4096),XXZ(4096),YY(4096),ZZ(4096)
      
C     initialize vertical window edges for autoscaling.
      if(iyscalez.eq.1)then
         YMAXZ=-1000.0
         YMINZ=1000.0
      endif
      if(iyscaley.eq.1)then
         YMAXY=-1000.0
         YMINY=1000.0
      endif

C     Set up plot data. XXY & YY are the slitless x and y coordinates for
C     upper window. 

      DO I=1,nslpix

C        Change x coordintes if plotting relative to zeropoint or not.
         if(izero.eq.1)then
            XXY(I)=FLOAT(I)-yzero
         else
            XXY(I)=FLOAT(I)
         endif
         YY(I)=SLPIX(I)
         if(iyscaley.eq.1)then
            if(xxy(i).le.xmaxy.and.xxy(i).ge.xminy)then
               YMAXY=MAX(YMAXY,YY(I))
               YMINY=MIN(YMINY,YY(I))
            endif
         endif
      END DO

C     XXZ & ZZ are the emission line x abd y coordinates for
C     lower window.

      DO I=1,nempix

C        Change x coordintes if plotting relative to zeropoint or not.
         if(izero.eq.1)then
            XXZ(I)=FLOAT(I)-zzero
         else
            XXZ(I)=FLOAT(I)
         endif

         ZZ(I)=EMPIX(I)
         if(iyscalez.eq.1)then
            if(xxz(i).le.xmaxz.and.xxz(i).ge.xminz)then
               YMAXZ=MAX(YMAXZ,ZZ(I))
               YMINZ=MIN(YMINZ,ZZ(I))
            endif
         endif
      END DO

C     Make head and foot room in plot.
      yax=ymaxy-yminy
      if(iyscaley.eq.1)then
         ymaxy=ymaxy+0.07*yax
         yminy=yminy-0.07*yax
         yax=ymaxy-yminy
      endif

C     Funky way to calculate how many tick marks in plot.
      lyax=int(log10(abs(yax)))
      ytick=10.**float(lyax)
      if ((yax/ytick).le.2.0) ytick=ytick/10.
      if ((yax/ytick).gt.6.0) ytick=ytick*2.
      if ((yax/ytick).gt.6.0) ytick=ytick*2.5
      ytickg=ytick

C     Make head and foot room in plot.
      yax=ymaxz-yminz
      if(iyscalez.eq.1)then
         ymaxz=ymaxz+0.07*yax
         yminz=yminz-0.07*yax
         yax=ymaxz-yminz
      endif

C     Funky way to calculate how many tick marks in plot.
      lyax=int(log10(abs(yax)))
      ytick=10.**float(lyax)
      if ((yax/ytick).le.2.0) ytick=ytick/10.
      if ((yax/ytick).gt.6.0) ytick=ytick*2.
      if ((yax/ytick).gt.6.0) ytick=ytick*2.5
      ytickf=ytick

C     Upper viewport first.
 10   xleft=0.07
      xright=0.93
      ybot=0.57
      ytop=0.945
      
      CALL PGSCH(0.7)

      call pgslw(3)
      call pgqci(ici)
      call pgsci(7)
      call pgpage
      Call PGSVP (XLEFT, XRIGHT, YBOT, YTOP)
      CALL PGSWIN (xminy, xmaxy, yminy, ymaxy)
      call pgbox('BCNST', 0., 0, 'BCNST', ytickg, 4)
      call pgslw(2)
      call pgsci(3)
      CALL PGLABEL('','COUNTS',top1)
      call pgslw(1)
      call pgsci(ici)
      if(ihisto.eq.0)then
         CALL PGLINE(nslpix,XXY,YY)
      else
         call pgbin(nslpix,xxy,yy,.true.)
      endif

C     Mark cloud peak positions.
      do i=1,nslc
         if(izero.eq.1)then
            x1=slc(idslc(i))
         else
            x1=slc(idslc(i))+yzero
         endif
         y1=sly(idslc(i))
         call pgnumb(idslc(i),0,0,idch,nc)
C         print*,x1,y1,' ',idch
         call pgptext(x1,y1,0.0,0.5,idch)
      enddo

C     Plot continuum.
      if(icont.eq.1)call pgline(nconty,xxy,conty)
      
C     Plot last multiple gaussian fits.
      do i=1,nslgfit
         call gaussplot(nslc,xxy,yzero,conty,slgpar,idslc,
     +        islmin(i),islmax(i))
      enddo

C     Plot last profile fits.
      do islc=1,nslc
         if(slpeak(islc).ne.0.0)call profplot(conty,xxy,nslpix,
     +        slcpeak(islc),slpeak(islc),slc80(islc),slw80(islc),
     +        slc50(islc),slw50(islc),slc20(islc),slw20(islc),
     +        slczero(islc),slwzero(islc))
      enddo

C     print status line.
      text='XXXXX'
      call statusline(text,6,1,0)

C     Move to lower viewport.
      ybot=ybot-0.5
      ytop=ytop-0.5

      call pgslw(3)
      call pgsci(7)
      Call PGSVP (XLEFT, XRIGHT, YBOT, YTOP)
      CALL PGSWIN (xminz, xmaxz, yminz, ymaxz)
      call pgbox('BCNST', 0., 0, 'BCNST', ytickf, 4)
      call pgslw(2)
      call pgsci(3)
      CALL PGLABEL('','COUNTS',top2)
      call pgslw(1)
      call pgsci(ici)
      if(ihisto.eq.0)then
         CALL PGLINE(nempix,XXZ,ZZ)
      else
         call pgbin(nempix,XXZ,ZZ,.true.)
      endif
C     Mark cloud peak positions.
      do i=1,nemc
         if(izero.eq.1)then
            x1=emc(idemc(i))
         else
            x1=emc(idemc(i))+zzero
         endif
         y1=emy(idemc(i))
         call pgnumb(idemc(i),0,0,idch,nc)
C         print*,x1,y1,' ',idch
         call pgptext(x1,y1,0.0,0.5,idch)
      enddo

C     Plot continuum.
      if(icont.eq.1)call pgline(ncontz,xxz,contz)

C     Plot last multiple gaussian fits.
      do i=1,nemgfit
         call gaussplot(nemc,xxz,zzero,contz,emgpar,idemc,
     +        iemmin(i),iemmax(i))
      enddo
C     Plot last profile fits.
      do iemc=1,nslc
         if(emc80(iemc).ne.0.0)call profplot(contz,xxz,nempix,
     +        emcpeak(iemc),empeak(iemc),emc80(iemc),emw80(iemc),
     +        emc50(iemc),emw50(iemc),emc20(iemc),emw20(iemc),
     +        emczero(iemc),emwzero(iemc))
      enddo

C     print status line. 
      text='XXXXX'
      call statusline(text,6,2,0)

C     Switch device back to xserve if just finished writing PostScript file.
      if(iprint.eq.1)then
         iprint=0
         call pgend
         call pgbegin(0,'2/xserve',1,1) 
         call pgask(.false.)
         goto 10
      endif

      RETURN
      
      END

*******************************************************************************

      subroutine cursopt

      common /gwindow/xmaxy,xminy,ymaxy,yminy,xmaxz,xminz,ymaxz,yminz
      common /gwindow2/yzero,zzero,xwindow,nslpix,nempix
      common /gwindow3/xleft,xright,ytop,ybot,ylen,xlen,xrange,yrange
      common /cursblock/x,y,chopt
      common /options/izero,ireplot,imark,iyscaley,iyscalez,
     +     iprint,ihisto,icont
      common /plotopt/mplot, plotname
      common /centers/slc(9),sly(9),idslc(9),nslc,
     +     emc(9),emy(9),idemc(9),nemc
      common /plotdata/XXY(4096),XXZ(4096),YY(4096),ZZ(4096)
      common /contin/conty(4096),contz(4096),nconty,ncontz
      common /gaussians/slgpar(9,3),islmin(10),islmax(10),nslgfit,
     +     emgpar(9,3),iemmin(10),iemmax(10),nemgfit
      common /profiles/slcpeak(9),slpeak(9),slc80(9),slw80(9),slc50(9),
     +     slw50(9),slc20(9),slw20(9),slczero(9),slwzero(9),slflux(9),
     +     emcpeak(9),empeak(9),emc80(9),emw80(9),emc50(9),emw50(9),
     +     emc20(9),emw20(9),emczero(9),emwzero(9),emflux(9)
      common /spect/disp, lambda0

      character chopt*1,outfile*60,sp*2,plotname*12,text*80

      integer frame
      real lambda0

C     Get cursor position and check if character input is a number.
 100  call fullcursor(x1,y1,frame)

      id=chtoint(chopt)      

C     Some initial parameters.
      
C     Default geusses for fwhm of Gaussian fits. Might want to make this
C     changeable.

      emfwhm=3
      slfwhm=3

C     Set to no replot initially
      ireplot=0
      
C     Save peak number (idslc, idemc for slitless and emission clouds 
C     respectively) and position (slc, sly, emc, emy) if character input 
C     is a number.

      if(id.ne.0) then
         if(frame.eq.1)then

C     Check for a change in mark.
            iremark=0
            do ii=1,nslc
               if(idslc(ii).eq.id)then
                  iremark=1
               endif
            enddo
            if(iremark.eq.0)then
               nslc=nslc+1
               idslc(nslc)=id
            endif

            if(izero.eq.1)then
               slc(id)=x1
            else
               slc(id)=x1-yzero
            endif
            sly(id)=y1
            write(text,'(''Slitless cloud #'',i1,'' marked at '',
     +           f6.2)')id,x1
            call statusline(text,6,frame,0)
C            print*,nslc,slc(id),sly(id),idslc(id)
         else
C     Check for a change in mark.
            iremark=0
            do ii=1,nemc
               if(idemc(ii).eq.id)then
                  iremark=1
               endif
            enddo
            if(iremark.eq.0)then
               nemc=nemc+1
               idemc(nemc)=id
            endif
            if(izero.eq.1)then
               emc(id)=x1
            else
               emc(id)=x1-zzero
            endif

            emy(id)=y1
            write(text,'(''Emission line cloud #'',i1,'' marked at '',
     +           f6.2)')id,x1
            call statusline(text,6,frame,0)
C            print*,nemc,emc(id),emy(id),idemc(id)
         endif
         call pgptext(x1,y1,0.0,0.5,chopt)
      endif

C     Toggle x coordinate from pixel values to relative to zero-point.
      if(chopt.eq.'z'.or.ch.eq.'Z') then
         ireplot=1
         if(izero.eq.1)then
            izero=0
            xminy=xminy+yzero
            xmaxy=xmaxy+yzero
            xminz=xminz+zzero
            xmaxz=xmaxz+zzero
         else
            izero=1
            xminy=xminy-yzero
            xmaxy=xmaxy-yzero
            xminz=xminz-zzero
            xmaxz=xmaxz-zzero
         endif

C     Set continuum to zero fopr all pixels.
      else if(chopt.eq.'b'.or.chopt.eq.'B')then
         write(*,'('' Continuum values set to zero.'')')
         if(frame.eq.1)then
            do i=1,nslpix
               conty(i)=0.0
            enddo
         else
            do i=1,nempix
               contz(i)=0.0
            enddo
         endif

C     Fit linear continuum to range of specified points.
      else if(chopt.eq.'c'.or.chopt.eq.'C')then
         write(*,'('' Continuum level fitting not yet implemented.'',
     +        ''Use D.'')')

C     Draw continuum by marking two points with cursor.
      else if(chopt.eq.'d'.or.chopt.eq.'D')then
         icont=1
         call fullcursor(x2,y2,frame)
         if(x2.eq.x1)then
            write(*,'(''No X-range. Redo.'')')
         else
            slope=(y2-y1)/(x2-x1)
            yint=y1-slope*x1
            if(frame.eq.1)then
               nconty=nslpix
               do i=1,nslpix
                  conty(i)=xxy(i)*slope+yint
               enddo
               call pgline(nconty,xxy,conty)
            else
               ncontz=nempix
               do i=1,ncontz
                  contz(i)=xxz(i)*slope+yint
               enddo
            endif
            call pgline(ncontz,xxz,contz)
         endif

C     Evaluate velocities  of cloud centers.
      else if(chopt.eq.'e'.or.chopt.eq.'E')then
         call results(6)
C     Autoscale window.
      else if(chopt.eq.'a'.or.chopt.eq.'A')then
         if(frame.eq.1)then
            iyscaley=1
            xminy=-xwindow/2.
            xmaxy=xwindow/2.
            if(izero.eq.0)then
               xminy=xminy+yzero
               xmaxy=xmaxy+yzero
            endif
         else
            iyscalez=1
            xminz=-xwindow/2.
            xmaxz=xwindow/2.
            if(izero.eq.0)then
               xminz=xminz+zzero
               xmaxz=xmaxz+zzero
            endif
         endif
         ireplot=1

C     Match x-scale in this window to scale in the other one.
      else if(chopt.eq.'m'.or.chopt.eq.'M')then
         ireplot=1
         if(izero.eq.0)then
            if(frame.eq.1)then
               xminy=xminz-zzero+yzero
               xmaxy=xmaxz-zzero+yzero
            else
               xminz=xminy-yzero+zzero
               xmaxz=xmaxy-yzero+zzero
            endif
         else
            if(frame.eq.1)then
               xminy=xminz
               xmaxy=xmaxz
            else
               xminz=xminy
               xmaxz=xmaxy
            endif
         endif

C     Mark vertical edges for window.
      else if(chopt.eq.'v'.or.chopt.eq.'V')then
         ireplot=1
         if(frame.eq.1)then
            iyscaley=0
            call fullcursor(x2,y2,frame)
            yminy=y1
            ymaxy=y2
            if(ymaxy.lt.yminy)then
               ymax2=yminy
               yminy=ymaxy
               ymaxy=ymax2
            endif
            if(ymaxy.eq.yminy)then
               write(*,'(''No Y-range.'')')
               yminy=yminy-1.0
               yminy=ymaxy+1.0
            endif
         else
            iyscalez=0
            call fullcursor(x2,y2,frame)
            yminz=y1
            ymaxz=y2
            if(ymaxz.lt.yminz)then
               ymax2=yminz
               yminz=ymaxz
               ymaxz=ymax2
            endif
            if(ymaxz.eq.yminz)then
               write(*,'(''No Y-range.'')')
               yminz=yminz-1.0
               yminz=ymaxz+1.0
            endif
         endif

C     write cuurent plot to PostScript output. Not fully implemented.
      else if(chopt.eq.'f'.or.chopt.eq.'F')then
         call pgend
         ireplot=1
         iprint=1
         mplot=mplot+1
         if(mplot.lt.10)then
            write(sp,'(i1)')mplot
            i1=1
            i2=1
         else if(mplot.lt.100.and.mplot.ge.10)then
            write(sp,'(i2)')mplot
            i1=1
            i2=2
         endif
         jj=istrlen(plotname, 12)
         outfile=plotname(1:jj)//sp(i1:i2)//'.ps/ps'
         jj=jj+i2+3
         write(text,'('' Creating PostScript file '',a,''.'')')
     +        outfile(1:jj)
         call pgbegin(0,outfile,1,1) 
         call pgask(.false.)

C     Mark Horizontal window edges.
      else if(chopt.eq.'h'.or.chopt.eq.'H')then
         ireplot=1
         if(frame.eq.1)then
            call fullcursor(x2,y2,frame)
            xminy=x1
            xmaxy=x2
            if(xmaxy.lt.xminy)then
               xmax2=xminy
               xminy=xmaxy
               xmaxy=xmax2
            endif
            if(xmaxy.eq.xminy)then
               write(*,'(''No X-range.'')')
               xminy=xminy-1.0
               xmaxy=xmaxy+1.0
            endif
         else
            call fullcursor(x2,y2,frame)
            xminz=x1
            xmaxz=x2
            if(xmaxz.lt.xminz)then
               xmax2=xminz
               xminz=xmaxz
               xmaxz=xmax2
            endif
            if(xmaxz.eq.xminz)then
               write(*,'(''No X-range.'')')
               xminz=xminz-1.0
               xmaxz=xmaxz+1.0
            endif
         endif

C     Gaussian fitting. First 'g' marks one edge of fitting region.
      else if (chopt.eq.'g'.or.chopt.eq.'G') then
         if (isetcont.eq.0)then
            write(*,'('' Continuum assumed set to zero.'')')
         endif
         if (frame.eq.1)then
            if(nslc.gt.0)then
               if(nslc.gt.1)then
                  write(*,'('' Fitting Gaussian to '',i1,
     +                 '' centers in Slitless spectrum.'')')nslc
               else
                  write(*,'('' Fitting Gaussian to '',i1,
     +                 '' center in Slitless spectrum.'')')nslc
               endif
               nslgfit=nslgfit+1
               call gaussfit(xxy,yy,yzero,conty,slc,nslc,idslc,
     +              nslpix,x1,y1,slfwhm,slgpar,islmin(nslgfit),
     +              islmax(nslgfit))
            else
               write(*,'(''No clouds marked in slitless frame.'')')
            endif
         else 
            if(nemc.gt.0)then
               if(nemc.gt.1)then
                  write(*,'('' Fitting Gaussian to '',i1,
     +                 '' centers in Emission line image.'')')nemc
               else
                  write(*,'('' Fitting Gaussian to '',i1,
     +                 '' center in Emission line image.'')')nemc
               endif
               nemgfit=nemgfit+1
               call gaussfit(xxz,zz,zzero,conty,emc,nemc,idemc,
     +              nempix,x1,y1,emfwhm,emgpar,iemmin(nemgfit),
     +              iemmax(nemgfit))
            else
               write(*,'(''No clouds marked in emission line frame.'')')
            endif
         endif

C     Profile analysis.
      else if (chopt.eq.'t'.or.chopt.eq.'T') then
         if(ihisto.eq.1)then
            ihisto=0
         else
            ihisto=1
         endif
         ireplot=1
      else if (chopt.eq.'i'.or.chopt.eq.'I') then
         if(frame.eq.1)then
            if(abs(ymaxy-yminy).lt.0.1.or.
     +           abs(ymaxy-yminy).gt.10000.)then
               write(text,'(''Cursor position --- X: '',f8.2,3x,
     +              ''Y: '',1pe10.4)')x1,y1
            else
               write(text,'(''Cursor position --- X: '',f8.2,3x,
     +              ''Y: '',f10.4)')x1,y1
            endif
         else
            if(abs(ymaxz-yminz).lt.0.1.or.
     +           abs(ymaxz-yminz).gt.10000.)then
               write(text,'(''Cursor position --- X: '',f8.2,3x,
     +              ''Y: '',1pe10.4)')x1,y1
            else
               write(text,'(''Cursor position --- X: '',f8.2,3x,
     +              ''Y: '',f10.4)')x1,y1
            endif
         endif
         call statusline(text,6,frame,0)
      else if (chopt.eq.'J'.or.chopt.eq.'j') then
         if(frame.eq.1)then
            iii=0
            do ii=2,nslpix
               if(xxy(ii).le.xmaxy.and.xxy(ii).ge.xminy)then
                  test1=x1-xxy(ii)
                  test2=x1-xxy(ii-1)
                  if(test1*test2.le.0.0)then
                     iii=ii
                     if(abs(test1).gt.abs(test2))iii=ii-1
                  endif
               endif
            enddo
            x2=xxy(iii)
            y2=yy(iii)
            if(abs(ymaxy-yminy).lt.0.1.or.
     +           abs(ymaxy-yminy).gt.10000.)then
               write(text,'(''Pixel value --- X: '',f8.2,3x,''Y: '',
     +              e10.4)')x2,y2
            else
               write(text,'(''Pixel value --- X: '',f8.2,3x,''Y: '',
     +              f10.4)')x2,y2
            endif
         else
            iii=0
            do ii=2,nslpix
               if(xxz(ii).le.xmaxz.and.xxz(ii).ge.xminz)then
                  test1=x1-xxz(ii)
                  test2=x1-xxz(ii-1)
                  if(test1*test2.le.0.0)then
                     iii=ii
                     if(abs(test1).gt.abs(test2))iii=ii-1
                  endif
               endif
            enddo
            x2=xxz(iii)
            y2=zz(iii)
            if(abs(ymaxz-yminz).lt.0.1.or.
     +           abs(ymaxz-yminz).gt.10000.)then
               write(text,'(''Pixel value --- X: '',f8.2,3x,''Y: '',
     +              e10.4)')x2,y2
            else
               write(text,'(''Pixel value --- X: '',f8.2,3x,''Y: '',
     +              f10.4)')x2,y2
            endif
         endif
         call statusline(text,6,frame,0)
      else if (chopt.eq.'p'.or.chopt.eq.'P') then
         if (frame.eq.1)then
            if(nslc.gt.0)then
               if(nslc.gt.1)then
                  xdmin=abs(x1-slc(idslc(1)))+1000.
                  do i=1,nslc
                     xdist=abs(x1-slc(idslc(i)))
                     if(xdist.lt.xdmin)then
                        xdmin=xdist
                        islc=i
                        idpeak=idslc(islc)
                     endif
                  enddo
                  write(*,'('' Profile analysis for peak #'',i1,
     +              '' in Slitless spectrum.'')')idpeak
               else
                  islc=1
                  idpeak=idslc(islc)
                  write(*,'('' Profile analysis for peak #'',i1,
     +              '' in Slitless spectrum.'')')idpeak
               endif

               write(text,'('' Profile: Mark peak (center and '',
     +              ''height simultaneously).'')')

               call statusline(text,6,frame,0)
               call profile(xxy,yy,conty,nslpix,x1,y1,xminy,xmaxy,
     +              yzero,slcpeak(idpeak),slpeak(idpeak),slc80(idpeak),
     +              slw80(idpeak),slc50(idpeak),slw50(idpeak),
     +              slc20(idpeak),slw20(idpeak),slczero(idpeak),
     +              slwzero(idpeak),slflux(idpeak))

            else
               write(*,'(''No clouds marked in slitless frame.'')')
            endif
         else 
            if(nemc.gt.0)then
               if(nemc.gt.1)then
                  xdmin=abs(x1-emc(idemc(1)))+1000.
                  do i=1,nemc
                     xdist=abs(x1-emc(idemc(i)))
                     if(xdist.lt.xdmin)then
                        xdmin=xdist
                        iemc=i
                        idpeak=idemc(iemc)
                     endif
                  enddo
                  write(*,'('' Profile analysis for peak #'',i1,
     +              '' in Emission line image.'')')idpeak
               else
                  iemc=1
                  idpeak=idemc(iemc)
                  write(*,'('' Profile analysis for peak #'',i1,
     +              '' in Emission line image.'')')idpeak
               endif
               write(text,'('' Profile: Mark peak (center and '',
     +              ''height simultaneously).'')')

               call statusline(text,6,frame,0)

               call profile(xxz,zz,contz,nempix,x1,y1,xminz,xmaxz,
     +              zzero,emcpeak(idpeak),empeak(idpeak),emc80(idpeak),
     +              emw80(idpeak),emc50(idpeak),emw50(idpeak),
     +              emc20(idpeak),emw20(idpeak),emczero(idpeak),
     +              emwzero(idpeak),emflux(idpeak))
            else 
               write(*,'(''No clouds marked in emission line frame.'')')
            endif
         endif
      else if (chopt.eq.'r') then
         ireplot=1
      else if (chopt.eq.'?') then
         write(*,'(''---------------------------------------------'',
     +        ''-------------------------'')')
         write(*,'(''                            Graph Options'')')   
         write(*,'(''---------------------------------------------'',
     +        ''-------------------------'')')
         write(*,'(''1,2,3,4,5,6,7,8 or 9 --- Mark cloud peaks'')')
         write(*,'(''a --- autoscale                            '',
     +        ''b --- set continuum at zero'')')
         write(*,'(''c --- fit continuum                        '',
     +        ''d --- draw continuum'')')
         write(*,'(''e --- evaluate velocities                  '',
     +        ''f --- write PostScript file'')')
         write(*,'(''g --- multiple Gaussian fits               '',
     +        ''h --- horiz. window edges'')')
         write(*,'(''i --- Cursor position                      '',
     +         ''j --- Pixel value'')')
         write(*,'(''m --- match horiz. window scale            '',
     +        ''p --- profile analysis'')')
         write(*,'(''q --- quit                                 '',
     +        ''r --- replot'')')
         write(*,'(''s --- show profile & Gauss. fits           '',
     +        ''t --- toggle line mode'')')
         write(*,'(''v --- vert. window edges                   '',
     +        ''z --- toggle zero point'')')
         write(*,'(''? --- commands                             '',
     +        '' '')')
         write(*,'(''---------------------------------------------'',
     +        ''-------------------------'')')
      else if(chopt.eq.'q'.or.chopt.eq.'Q')then
         if(nslc.ne.0.or.nemc.ne.0)then
            write(*,'(''Keep results? (y or n; y): '',$)')
            read(*,'(a)')chopt
            ikeep=1
            if(chopt.eq.'n')ikeep=0
         else if(nslc.eq.0.and.nemc.eq.0)then
            ikeep=0
         endif
         chopt='q'
         if(ikeep.eq.1)call results(11)
      else
         goto 100
      endif

C      print*,x,y,x1,y1,frame,' ',chopt
C      call pgpt(1,x1,y1,17)
      
      return
      end

*******************************************************************************

      subroutine fullcursor(x1,y1,frame)

      common /gwindow/xmaxy,xminy,ymaxy,yminy,xmaxz,xminz,ymaxz,yminz
      common /gwindow2/yzero,zzero,xwindow,nslpix,nempix
      common /gwindow3/xleft,xright,ytop,ybot,ylen,xlen,xrange,yrange
      common /cursblock/x,y,chopt
      common /options/izero,ireplot,imark,iyscaley,iyscalez,
     +     iprint,ihisto,icont

      integer frame
      character chopt*1

C     Set viewport to whole page, upper and lower plots, for cursor input.
      xleft=0.07
      xright=0.93
      ybot=0.07
      ytop=0.945

      jmark=1

      Call PGSVP (XLEFT, XRIGHT, YBOT, YTOP)
      CALL PGSWIN (xleft, xright, ybot, ytop)

C     Make crosshairs red.
      call pgqci(ici)
      call pgsci(2)

C     Xref and Yref are ignored by pgband for this cursor.
      xref=0.0
      yref=0.0
      jcur=7

      call pgband(jcur,0,xref,yref,x,y,chopt)

C      i=PGCURS (X, Y, CHOPT)
      call pgsci(ici)

C     check if character input from cursor is a number. If it is don't
C     mark with a point.

      id=chtoint(chopt)
      if(id.ne.0)jmark=0

C     If character input is one of these don't mark with a point.
      if(chopt.eq.'g'.or.chopt.eq.'G') jmark=0
      if(chopt.eq.'c'.or.chopt.eq.'C') jmark=0
      if(chopt.eq.'?'.or.chopt.eq.'?') jmark=0
      if(chopt.eq.'q'.or.chopt.eq.'Q') return

C     Decide which plot the cursor was marked in. frame =1 is upper
C     frame=2 is lower.

      frame=2
      if(y.ge.0.5)frame=1

C     revert back to upper or lower window viewport settings.
      if(frame.eq.1)then
         ybot=0.57
         ytop=0.945
         ylen=ytop-ybot
         xlen=xright-xleft
         yrange=ymaxy-yminy
         xrange=xmaxy-xminy
         y1=yminy+(y-ybot)*yrange/ylen
         x1=xminy+(x-xleft)*xrange/xlen
         call pgsch(0.7)
         call pgsvp (xleft, xright, ybot, ytop)
         call pgswin (xminy, xmaxy, yminy, ymaxy)
      else
         ybot=0.07
         ytop=0.445
         ylen=ytop-ybot
         xlen=xright-xleft
         yrange=ymaxz-yminz
         xrange=xmaxz-xminz
         y1=yminz+(y-ybot)*yrange/ylen
         x1=xminz+(x-xleft)*xrange/xlen
         call pgsch(0.7)
         call pgsvp (xleft, xright, ybot, ytop)
         call pgswin (xminz, xmaxz, yminz, ymaxz)
      endif

      if(imark.eq.1.and.jmark.eq.1) call pgpt(1,x1,y1,17)

C      print*,x,y,x1,y1,frame,' ',chopt

      return
      end

*******************************************************************************

      function chtoint(in)
      character in*(*),string*9

      string='123456789'
      chtoint=0
      do j=1,9
         if(in(1:1).eq.string(j:j))chtoint=j
      enddo

      return
      end

*******************************************************************************

      subroutine gaussfit(xx,yy,zero,ycont,c,nc,idc,npix,x1,y1,
     +     fwhm,gpar,imin,imax)

      common /options/izero,ireplot,imark,iyscaley,iyscalez,
     +     iprint,ihisto,icont
      common/gfit/xxx(4096),yyy(4096),yc(4096),nfit,ng
      common /cursblock/x,y,chopt

      real c(9),xx(4096),yy(4096)
      real param(27),params(28,27),values(28), par(3)
      real ycont(4096),gpar(9,3)
      character chopt*1
      integer idg(9),idc(9)

C     Get second edge of fitting region.
      call fullcursor(x2,y2,frame)

      xmax=x2    
      xmin=x1
      if(xmax.lt.xmin)then
         xmax2=xmin
         xmin=xmax
         xmax=xmax
      endif
      if(xmax.eq.xmin)then
         write(*,'(''No X-range.'')')
         return
      endif

C     Find array indices for points in the fitting range. Value of test1
C     and test2 will be negative only when i and i-1 lie on either side of 
C     edge.

      imin=1
      imax=4096
      do i=2,npix
         test1=(xmin-xx(i))*(xmin-xx(i-1))
         test2=(xmax-xx(i))*(xmax-xx(i-1))
         if(test1.le.0.0)imin=i
         if(test2.le.0.0)imax=i
      enddo
      ymax=-10000000000.
      nfit=imax-imin+1

      do i=imin,imax
         j=i-imin+1
         xxx(j)=xx(i)
         yyy(j)=yy(i)
         yc(j)=ycont(i)
         ymax=max((yyy(j)-yc(j)),ymax)
      enddo

C     Color the fitted spectrum Red.
      call pgqci(ici)
      call pgsci(2)

      if(ihisto.eq.0)then
         call pgline(nfit,xxx,yyy)
      else
         call pgbin(nfit,xxx,yyy,.true.)
      endif
      call pgsci(ici)

C     Subtract continuum and divide by max to get normalized values. Also
C     be sure to fit relative to zero-point.
      do j=1,nfit
         if(izero.eq.0)xxx(j)=xxx(j)-zero
         yyy(j)=(yyy(j)-yc(j))/ymax
      enddo

C     Start counting parameters for fit and initialize starting input array
C     to amoeba (param). Start with peak centers and check that center falls in
C     the fit range.

      npar=0
      ng=0
      do i=1,nc
         do k=2,nfit
            test=(xxx(k)-c(idc(i)))*(xxx(k-1)-c(idc(i)))
            if(test.le.0.0)then
               ng=ng+1
               npar=npar+1
               param(npar)=c(idc(i))
               idg(ng)=idc(i)
            endif
         enddo
C         print*,npar,param(npar),'   Center'
      enddo

C     set intial geuss for sigmas.
      do j=1,ng
         npar=npar+1
         param(npar)=fwhm/2.35
C         print*,npar,param(npar),'  Sigma'
      enddo
      
C     Get initial geuss for Gaussian amplituides from pixel value at
C     cursor. Use same test strategy above to tell when you have the right
C     array index.

      do j=1,ng
C        print*,c(j),xxx(2),xxx(nfit)
         do i=2,nfit
            test=(c(idg(j))-xxx(i))*(c(idg(j))-xxx(i-1))
            if(test.le.0.0)then
               npar=npar+1
               param(npar)=yyy(i)
C               print*,npar,param(npar),'   Amplitude'
            endif
         enddo
      enddo

C     Bump some values to form initial simplex for amoeba subroutine. (See
C     Numerical Recipes Book Section 10.4 p.289).

      factor=1.1
      addin=0.75*fwhm/2.35
      do i=1,npar+1
         do j=1,npar
            params(i,j)=param(j)
            if(i.eq.j)then
               if(i.eq.1)then
                  params(i,j)=params(i,j)-addin
               else
                  params(i,j)=params(i,j)*factor
               endif
            endif
         enddo
      enddo
      
C     Evaluate function at vertices of simplex before running amoeba.
      do i=1,npar+1
         do j=1,npar
            param(j)=params(i,j)
         enddo
         values(i)=amgres1(param)
C         print*,i,values(i),(params(i,j),j=1,npar)
      enddo

C     Plot initial geusses.

C      do j=1,npar+1
C         do i=1,npar
C            param(i)=params(j,i)
C         enddo
c         
C         call amgauss(param,yyz)
C         do i=1,nfit
C            yyz(i)=yyz(i)*ymax+yc(i)
C            xxz(i)=xxx(i)
C         enddo         
C      call pgqci(ici)
C      call pgsci(3)
C      call pgline(nfit,xxz,yyz)
C      call pgsci(ici)
C      enddo
      
C     Lots of paramters possible for up to 9 Gaussians in fit.
      mpar=28
      jpar=27
      ftol=0.0001

      call amoeba(params,values,mpar,jpar,npar,ftol,amgres1,iter)

C     take first returned vertex as best; should be OK since all
C     solutions are with in ftol of each other.

      do i=1,npar
         param(i)=params(1,i)
      enddo
      
C     Print out fit results on screen.
      write(*,'(''------------------------------------------------'')')
      write(*,'(''  #   Center     Sigma    Amplitude       R.M.S.'')')
      write(*,'(''------------------------------------------------'')')
      do j=1,ng
         par(1)=param(j)
         par(2)=param(j+ng)
         par(3)=param(j+2*ng)

         gpar(idg(j),1)=par(1)
         gpar(idg(j),2)=par(2)
         gpar(idg(j),3)=sqrt(par(3)*par(3))*ymax

         ampvalue=sqrt(par(3)*par(3))*ymax
         if(ampvalue.ge.100.0)then
            write(*,'(2x,i1,2x,f7.2,3x,f7.2,3x,i10,3x,f10.5)')
     +           idg(j),par(1),par(2),nint(ampvalue),values(j)
         else if(ampvalue.lt.200.0.and.ampvalue.ge.0.2)then
            write(*,'(2x,i1,2x,f7.2,3x,f7.2,3x,f10.3,3x,f10.5)')
     +           idg(j),par(1),par(2),ampvalue,values(j)
         else if(ampvalue.lt.0.2.and.ampvalue.ge.1.0e-5)then
            write(*,'(2x,i1,2x,f7.2,3x,f7.2,3x,f10.7,3x,f10.5)')
     +           idg(j),par(1),par(2),ampvalue,values(j)
         else if(ampvalue.lt.1.0e-5)then
            write(*,'(2x,i1,2x,f7.2,3x,f7.2,3x,1pe10.4,3x,0pf10.5)')
     +           idg(j),par(1),par(2),ampvalue,values(j)
         endif

      enddo

      write(*,'(''------------------------------------------------'')')

C     Plot resulting individual Gaussians and sum.

      call gaussplot(nc,xx,zero,ycont,gpar,idg,imin,imax)

      return
      end

*****************************************************************************

	subroutine amgauss(param,gaussm)
C     Evaluate multiple Gaussians.

        common/gfit/xxx(4096),yyy(4096),yc(4096),nfit,ng

        real param(*),gaussm(4096)
        
        do i=1,nfit
           gaussm(i)=0.
           do j=1,ng
              k=j+ng
              l=k+ng
              aaa=(xxx(i)-param(j))*(param(j)-xxx(i))/
     +             (2.*param(k)*param(k))
              if(abs(aaa).lt.50.0)then
                 gaussm(i)=gaussm(i)+param(l)*exp(aaa)
              endif
           enddo
        enddo
        return
	end

*****************************************************************************

	subroutine gauss1(par,gauss)
C     Evaluate single Gaussians for plotting.

        common/gfit/xxx(4096),yyy(4096),yc(4096),nfit,ng

        real par(*),gauss(4096)
        
        do i=1,nfit
           aaa=(xxx(i)-par(1))*(par(1)-xxx(i))/(2.*par(2)*par(2))
           if(abs(aaa).lt.50.0)then
              gauss(i)=par(3)*exp(aaa)
           else
              gauss(i)=0.0
           endif
        enddo
        return
	end

*****************************************************************************

	function amgres1(param)
C     Function to minimize for best fit.

        common/gfit/xxx(4096),yyy(4096),yc(4096),nfit,ng

        real param(*)
        
        sumres2=0.0
        do i=1,nfit
           gaussm=0.
           do j=1,ng
              k=j+ng
              l=k+ng
              amp=sqrt(param(l)*param(l))
              aaa=(xxx(i)-param(j))*
     +             (param(j)-xxx(i))/(2.*param(k)*param(k))
              if(abs(aaa).lt.50.0)then
                 gaussm=gaussm+amp*exp(aaa)
              endif
           enddo
           sumres2=sumres2+(yyy(i)-gaussm)*(yyy(i)-gaussm)
        enddo
        amgres1=sqrt(sumres2/float(nfit-1))
	return
	end

*****************************************************************************

	function amgres2(param)

C     Function to minimize for best fit.
C     Require equal widths.

        common/gfit/xxx(4096),yyy(4096),yc(4096),nfit,ng

        real param(*)
        
        do i=1,nfit
           gaussm=0.
           k=ng+1
           do j=1,ng
              l=j+ng+1
              aaa=(xxx(i)-param(j))*
     +             (param(j)-xxx(i))/(2.*param(k)*param(k))
              if(abs(aaa).lt.50.0)then
                 gaussm=gaussm+param(l)*exp(aaa)
              endif
           enddo
           sumres2=sumres2+(yyy(i)-gaussm)*(yyy(i)-gaussm)
        enddo
        amgres2=sqrt(sumres2/float(nfit-1))
	return
	end

****************************************************************************

	SUBROUTINE amoeba(p,y,mp,np,ndim,ftol,funk,iter)

C     Added the folowing common block.
        common/gfit/xxx(4096),yyy(4096),yc(4096),nfit,ng

	INTEGER iter,mp,ndim,np,NMAX,ITMAX
	REAL ftol,p(mp,np),y(mp),funk,ALPHA,BETA,GAMMA
	EXTERNAL funk
	PARAMETER (NMAX=30,ALPHA=1.0,BETA=0.5,GAMMA=2.0,ITMAX=2000)
	INTEGER i,ihi,ilo,inhi,j,mpts
	REAL rtol,ypr,yprr,pbar(NMAX),pr(NMAX),prr(NMAX)
	mpts=ndim+1
	iter=0
1	ilo=1
	if(y(1).gt.y(2))then
		ihi=1
		inhi=2
	else
		ihi=2
		inhi=1
	endif
	do i=1,mpts
		if(y(i).lt.y(ilo)) ilo=i
		if(y(i).gt.y(ihi))then
			inhi=ihi
			ihi=i
		else if(y(i).gt.y(inhi))then
			if(i.ne.ihi) inhi=i
		endif
	enddo
	rtol=2.*abs(y(ihi)-y(ilo))/(abs(y(ihi))+abs(y(ilo)))
	if(rtol.lt.ftol)return
C	if(iter.eq.ITMAX) pause 'amoeba exceeding maximum iterations.'
	if(iter.eq.ITMAX) return
	iter=iter+1
	do j=1,ndim
		pbar(j)=0.
	enddo
	do i=1,mpts
		if(i.ne.ihi)then
			do j=1,ndim
				pbar(j)=pbar(j)+p(i,j)
			enddo
		endif
	enddo
	do j=1,ndim
		pbar(j)=pbar(j)/ndim
		pr(j)=(1.+ALPHA)*pbar(j)-ALPHA*p(ihi,j)
	enddo
	ypr=funk(pr)
	if(ypr.le.y(ilo))then
		do j=1,ndim
			prr(j)=GAMMA*pr(j)+(1.-GAMMA)*pbar(j)
		enddo
		yprr=funk(prr)
		if(yprr.lt.y(ilo))then
			do j=1,ndim
				p(ihi,j)=prr(j)
			enddo
			y(ihi)=yprr
		else
			do j=1,ndim
				p(ihi,j)=pr(j)
			enddo
			y(ihi)=ypr
		endif
	else if(ypr.ge.y(inhi))then
		if(ypr.lt.y(ihi))then
			do j=1,ndim
				p(ihi,j)=pr(j)
			enddo
			y(ihi)=ypr
		endif
		do j=1,ndim
			prr(j)=BETA*p(ihi,j)+(1.-BETA)*pbar(j)
		enddo
		yprr=funk(prr)
		if(yprr.lt.y(ihi))then
			do j=1,ndim
				p(ihi,j)=prr(j)
			enddo
			y(ihi)=yprr
		else
			do i=1,mpts
				if(i.ne.ilo)then
					do j=1,ndim
						pr(j)=0.5*(p(i,j)+p(ilo,j))
						p(i,j)=pr(j)
					enddo
					y(i)=funk(pr)
				endif
			enddo
		endif
	else
		do j=1,ndim
			p(ihi,j)=pr(j)
		enddo
		y(ihi)=ypr
	endif
	go to 1
	END

******************************************************************************

        subroutine profile(xx,yy,ycont,npix,x1,y1,xmin,xmax,zero,
     +     cpeak,ypeak,c80,w80,c50,w50,c20,w20,czero,wzero,sum)

        common /options/izero,ireplot,imark,iyscaley,iyscalez,
     +     iprint,ihisto,icont
        common /cursblock/x,y,chopt
        common /plotopt/mplot, plotname

        character chopt*1, plotname*12, text*80
        real xx(4096),yy(4096),ycont(4096)
        
C     Profile analysis
        call fullcursor(x2,y2,frame)

        ypeakx=y2
        cpeakx=x2

        cpeak=x2
        if(izero.eq.0)cpeak=cpeak-zero

        ipeak=0
        do i=2,npix
           if(xx(i).ge.xmin.and.xx(i).le.xmax)then
              test1=(xx(i)-x2)
              test2=(xx(i-1)-x2)
              if(test1*test2.le.0.0)then
                 ipeak=i
                 if(abs(test2).lt.abs(test1))ipeak=i-1
              endif
           endif
        enddo

        j2=ipeak+20
        j1=ipeak-20
        if(j1.le.0)j1=1
        if(j2.gt.4096)j2=4096
        
        sc=(ycont(j2)-ycont(j1))/(xx(j2)-xx(j1))
        y0=ycont(j1)-sc*xx(j1)

        write(text,'(''Profile: Mark left and right wings.'')')

        call statusline(text,6,frame,0)

        call fullcursor(x3,y3,frame)
        call fullcursor(x4,y4,frame)

        if(x3.gt.x4)then
           xw2=x3
           xw1=x4
        else
           xw1=x3
           xw2=x4
        endif

        czero=(xw1+xw2)/2.0
        if(izero.eq.0)czero=czero-zero
        wzero=abs(xw2-xw1)

C       Set up 80%, 50%, and 20% levels.
        ypeak=ypeakx-sc*cpeakx-y0

        y80=ypeak*0.8
        y50=ypeak*0.5
        y20=ypeak*0.2

C       Get line flux.
        i1=ipeak
        i2=ipeak-1
        test01=(yy(i1)-ycont(i1))*(yy(i2)-ycont(i2))
        do while (test01.ge.0.0)
           i1=i1-1
           i2=i2-1
           test01=(yy(i1)-ycont(i1))*(yy(i2)-ycont(i2))
        enddo
        iw1=i1
        
        j1=ipeak
        j2=ipeak+1
        test02=(yy(j1)-ycont(j1))*(yy(j2)-ycont(j2))
        do while (test02.ge.0.0)
           j1=j1+1
           j2=j2+1
           test02=(yy(j1)-ycont(j1))*(yy(j2)-ycont(i2))
        enddo
        iw2=j1
        sum=0.0
        do i=iw1,iw2
           sum=sum+yy(i)-ycont(i)
        enddo
        
        if(ipeak.ne.0)then
C          Profile analysis options.
           write(text,'(''Options: a - automatic fit    '',
     +          ''m - manual fit'')')

           call statusline(text,6,frame,0)
           call fullcursor(x1,y1,frame)

C          Automatic mode. Good for high signal to noise where.
C          the profile crosses % levels at no more than two points
C          No error  analysis here.

           if(chopt.eq.'a'.or.chopt.eq.'A') then
C             Test for left side of profile crossing 80% level. Keep 
C             array indices, i1 and i2,  on either side of crossing.
              i1=ipeak
              i2=ipeak-1
              test81=(yy(i1)-ycont(i1)-y80)*(yy(i2)-ycont(i2)-y80)
              do while (test81.ge.0.0)
                 i1=i1-1
                 i2=i2-1
                 test81=(yy(i1)-ycont(i1)-y80)*(yy(i2)-ycont(i2)-y80)
                 if(test81.lt.0.0)then
                    i1x=0
                    i2x=0

C                   Check three more pixels for other level crossings
C                   just to be sure and to be slightly more robust.
C                   Save in i1x and i2x,
                    do ijk=1,3
                       ii1=i1-ijk
                       ii2=i2-ijk
                       test81x=(yy(ii1)-ycont(ii1)-y80)*
     +                      (yy(ii2)-ycont(ii2)-y80)
                       if(test81x.lt.0.0)then
                          i1x=ii1
                          i2x=ii2
                       endif
                    enddo
                 endif
              enddo     

C             If more than one level crossing take mean of first and last.
              if(i1x.ne.0.and.i2x.ne.0)then
                 i1=nint(float(i1+i1x)/2.0)
                 i2=nint(float(i2+i2x)/2.0)
              endif

C             Find intersection between line parallel to continuum at 80%
C             and line connecting pixel values at i1 and i2. This is the
C             best geuss for the x-y values of the crossing. This is because
C             no continuum subtraction has been done yet.

              s1=(yy(i2)-yy(i1))/(xx(i2)-xx(i1))
              sc=(ycont(i2+10)-ycont(i1-10))/(xx(i2+10)-xx(i1-10))
              y0=yy(i1)-s1*xx(i1)
              yc0=ycont(i1)-sc*xx(i1)+y80
              x81=(yc0-y0)/(s1-sc)
              y81=x81*s1+y0

C             Test for right side of profile crossing 80% level
              j1=ipeak
              j2=ipeak+1
              test82=(yy(j1)-ycont(j1)-y80)*(yy(j2)-ycont(j2)-y80)
              do while (test82.ge.0.0)
                 j1=j1+1
                 j2=j2+1
                 test82=(yy(j1)-ycont(j1)-y80)*(yy(j2)-ycont(j2)-y80)
                 if(test82.lt.0.0)then

C                   Check three more pixels for other level crossings
C                   just to be sure and to be slightly more robust.
C                   Save in i1x and i2x,

                    j1x=0
                    j2x=0
                    do ijk=1,3
                       jj1=j1+ijk
                       jj2=j2+ijk
                       test82x=(yy(jj1)-ycont(jj1)-y80)*
     +                      (yy(jj2)-ycont(jj2)-y80)
                       if(test82x.lt.0.0)then
                          j1x=jj1
                          j2x=jj2
                       endif
                    enddo
                 endif
              enddo     

C             If more than one level crossing take mean of first and last.
              if(j1x.ne.0.and.j2x.ne.0)then
                 j1=nint(float(j1+j1x)/2.0)
                 j2=nint(float(j2+j2x)/2.0)
              endif

C             Find intersection between line parallel to continuum at 80%
C             and line connecting pixel values at i1 and i2. This is the
C             best geuss for the x-y values of the crossing. This is because
C             no continuum subtraction has been done yet.

              s1=(yy(j2)-yy(j1))/(xx(j2)-xx(j1))
              sc=(ycont(j2+10)-ycont(j1-10))/(xx(j2+10)-xx(j1-10))
              y0=yy(j1)-s1*xx(j1)
              yc0=ycont(j1)-sc*xx(j1)+y80
              x82=(yc0-y0)/(s1-sc)
              y82=x82*s1+y0

              c80=(x81+x82)/2.
              if(izero.eq.0)c80=c80-zero
              y80x=(y81+y82)/2.
              w80=abs(x82-x81)

C             Test for left side of profile crossing 50% level. Keep 
C             array indices, i1 and i2,  on either side of crossing.
              i1=ipeak
              i2=ipeak-1
              test51=(yy(i1)-ycont(i1)-y50)*(yy(i2)-ycont(i2)-y50)
              do while (test51.ge.0.0)
                 i1=i1-1
                 i2=i2-1
                 test51=(yy(i1)-ycont(i1)-y50)*(yy(i2)-ycont(i2)-y50)
                 if(test51.lt.0.0)then
                    i1x=0
                    i2x=0

C                   Check three more pixels for other level crossings
C                   just to be sure and to be slightly more robust.
C                   Save in i1x and i2x,
                    do ijk=1,3
                       ii1=i1-ijk
                       ii2=i2-ijk
                       test51x=(yy(ii1)-ycont(ii1)-y50)*
     +                      (yy(ii2)-ycont(ii2)-y50)
                       if(test51x.lt.0.0)then
                          i1x=ii1
                          i2x=ii2
                       endif
                    enddo
                 endif
              enddo     

C             If more than one level crossing take mean of first and last.
              if(i1x.ne.0.and.i2x.ne.0)then
                 i1=nint(float(i1+i1x)/2.0)
                 i2=nint(float(i2+i2x)/2.0)
              endif

C             Find intersection between line parallel to continuum at 50%
C             and line connecting pixel values at i1 and i2. This is the
C             best geuss for the x-y values of the crossing. This is because
C             no continuum subtraction has been done yet.

              s1=(yy(i2)-yy(i1))/(xx(i2)-xx(i1))
              sc=(ycont(i2+10)-ycont(i1-10))/(xx(i2+10)-xx(i1-10))
              y0=yy(i1)-s1*xx(i1)
              yc0=ycont(i1)-sc*xx(i1)+y50
              x51=(yc0-y0)/(s1-sc)
              y51=x51*s1+y0

C             Test for right side of profile crossing 50% level
              j1=ipeak
              j2=ipeak+1
              test52=(yy(j1)-ycont(j1)-y50)*(yy(j2)-ycont(j2)-y50)
              do while (test52.ge.0.0)
                 j1=j1+1
                 j2=j2+1
                 test52=(yy(j1)-ycont(j1)-y50)*(yy(j2)-ycont(j2)-y50)
                 if(test52.lt.0.0)then

C                   Check three more pixels for other level crossings
C                   just to be sure and to be slightly more robust.
C                   Save in i1x and i2x,

                    j1x=0
                    j2x=0
                    do ijk=1,3
                       jj1=j1+ijk
                       jj2=j2+ijk
                       test52x=(yy(jj1)-ycont(jj1)-y50)*
     +                      (yy(jj2)-ycont(jj2)-y50)
                       if(test52x.lt.0.0)then
                          j1x=jj1
                          j2x=jj2
                       endif
                    enddo
                 endif
              enddo     

C             If more than one level crossing take mean of first and last.
              if(j1x.ne.0.and.j2x.ne.0)then
                 j1=nint(float(j1+j1x)/2.0)
                 j2=nint(float(j2+j2x)/2.0)
              endif

C             Find intersection between line parallel to continuum at 50%
C             and line connecting pixel values at i1 and i2. This is the
C             best geuss for the x-y values of the crossing. This is because
C             no continuum subtraction has been done yet.

              s1=(yy(j2)-yy(j1))/(xx(j2)-xx(j1))
              sc=(ycont(j2+10)-ycont(j1-10))/(xx(j2+10)-xx(j1-10))
              y0=yy(j1)-s1*xx(j1)
              yc0=ycont(j1)-sc*xx(j1)+y50
              x52=(yc0-y0)/(s1-sc)
              y52=x52*s1+y0

              c50=(x51+x52)/2.
              if(izero.eq.0)c50=c50-zero
              y50x=(y51+y52)/2.
              w50=abs(x52-x51)

C             Test for left side of profile crossing 20% level. Keep 
C             array indices, i1 and i2,  on either side of crossing.
              i1=ipeak
              i2=ipeak-1
              test21=(yy(i1)-ycont(i1)-y20)*(yy(i2)-ycont(i2)-y20)
              do while (test21.ge.0.0)
                 i1=i1-1
                 i2=i2-1
                 test21=(yy(i1)-ycont(i1)-y20)*(yy(i2)-ycont(i2)-y20)
                 if(test21.lt.0.0)then
                    i1x=0
                    i2x=0

C                   Check three more pixels for other level crossings
C                   just to be sure and to be slightly more robust.
C                   Save in i1x and i2x,
                    do ijk=1,3
                       ii1=i1-ijk
                       ii2=i2-ijk
                       test21x=(yy(ii1)-ycont(ii1)-y20)*
     +                      (yy(ii2)-ycont(ii2)-y20)
                       if(test21x.lt.0.0)then
                          i1x=ii1
                          i2x=ii2
                       endif
                    enddo
                 endif
              enddo     

C             If more than one level crossing take mean of first and last.
              if(i1x.ne.0.and.i2x.ne.0)then
                 i1=nint(float(i1+i1x)/2.0)
                 i2=nint(float(i2+i2x)/2.0)
              endif

C             Find intersection between line parallel to continuum at 20%
C             and line connecting pixel values at i1 and i2. This is the
C             best geuss for the x-y values of the crossing. This is because
C             no continuum subtraction has been done yet.

              s1=(yy(i2)-yy(i1))/(xx(i2)-xx(i1))
              sc=(ycont(i2+10)-ycont(i1-10))/(xx(i2+10)-xx(i1-10))
              y0=yy(i1)-s1*xx(i1)
              yc0=ycont(i1)-sc*xx(i1)+y20
              x21=(yc0-y0)/(s1-sc)
              y21=x21*s1+y0

C             Test for right side of profile crossing 20% level
              j1=ipeak
              j2=ipeak+1
              test22=(yy(j1)-ycont(j1)-y20)*(yy(j2)-ycont(j2)-y20)
              do while (test22.ge.0.0)
                 j1=j1+1
                 j2=j2+1
                 test22=(yy(j1)-ycont(j1)-y20)*(yy(j2)-ycont(j2)-y20)
                 if(test22.lt.0.0)then

C                   Check three more pixels for other level crossings
C                   just to be sure and to be slightly more robust.
C                   Save in i1x and i2x,

                    j1x=0
                    j2x=0
                    do ijk=1,3
                       jj1=j1+ijk
                       jj2=j2+ijk
                       test22x=(yy(jj1)-ycont(jj1)-y20)*
     +                      (yy(jj2)-ycont(jj2)-y20)
                       if(test22x.lt.0.0)then
                          j1x=jj1
                          j2x=jj2
                       endif
                    enddo
                 endif
              enddo     

C             If more than one level crossing take mean of first and last.
              if(j1x.ne.0.and.j2x.ne.0)then
                 j1=nint(float(j1+j1x)/2.0)
                 j2=nint(float(j2+j2x)/2.0)
              endif

C             Find intersection between line parallel to continuum at 20%
C             and line connecting pixel values at i1 and i2. This is the
C             best geuss for the x-y values of the crossing. This is because
C             no continuum subtraction has been done yet.

              s1=(yy(j2)-yy(j1))/(xx(j2)-xx(j1))
              sc=(ycont(j2+10)-ycont(j1-10))/(xx(j2+10)-xx(j1-10))
              y0=yy(j1)-s1*xx(j1)
              yc0=ycont(j1)-sc*xx(j1)+y20
              x22=(yc0-y0)/(s1-sc)
              y22=x22*s1+y0

              c20=(x21+x22)/2.
              if(izero.eq.0)c20=c20-zero
              y20x=(y21+y22)/2.
              w20=abs(x22-x21)

              call profplot(ycont,xx,npix,cpeak,ypeak,c80,w80,
     +             c50,w50,c20,w20,czero,wzero)
              write(text,'('' C80='',f7.2,2x,''C50='',f7.2,2x,
     +             ''FWHM='',f6.2)')C80,C50,W50
              call statusline(text,6,frame,0)

           else if(chopt.eq.'m'.or.chopt.eq.'M') then

              do i=2,npix
                 if(xx(i).ge.xmin.and.xx(i).le.xmax)then
                    test1=(xx(i)-cpeak)
                    test2=(xx(i-1)-cpeak)
                    if(test1*test2.le.0.0)then
                       ipeak=i
                       if(abs(test2).lt.abs(test1))ipeak=i-1
                    endif
                 endif
              enddo
              j2=ipeak+20
              j1=ipeak-20
              if(j1.le.0)j1=1
              if(j2.gt.4096)j2=4096
              
              sc=(ycont(j2)-ycont(j1))/(xx(j2)-xx(j1))
              y0=ycont(j1)-sc*xx(j1)
              
              xx1=czero-wzero/2.0
              xx2=czero+wzero/2.0
              yy1=xx1*sc+y0+y80
              yy2=xx2*sc+y0+y80

              if(izero.eq.0)then
                 xx1=xx1+zero
                 xx2=xx2+zero
              endif

C              print*,xx1,yy1,xx2,yy2

              call pgqci(ici)
              call pgsci(3)
              call pgmove(xx1,yy1)
              call pgdraw(xx2,yy2)
              call pgsci(ici)

              write(text,'(''Mark left and right 80% cuts.'')')
              call statusline(text,6,frame,0)
              call fullcursor(x81,y1,frame)
              call fullcursor(x82,y2,frame)

              if(x82.lt.x81)then
                 xx81=x81
                 x81=x82
                 x82=xx81
              endif

              c80=(x81+x82)/2.
              if(izero.eq.0)c80=c80-zero
              y80x=(y81+y82)/2.
              w80=abs(x82-x81)

              yy1=xx1*sc+y0+y50
              yy2=xx2*sc+y0+y50

              call pgqci(ici)
              call pgsci(3)
              call pgmove(xx1,yy1)
              call pgdraw(xx2,yy2)
              call pgsci(ici)

              write(text,'(''Mark left and right 50% cuts.'')')
              call statusline(text,6,frame,0)
              call fullcursor(x51,y1,frame)
              call fullcursor(x52,y2,frame)

              if(x52.lt.x51)then
                 xx51=x51
                 x51=x52
                 x52=xx51
              endif

              c50=(x51+x52)/2.
              if(izero.eq.0)c50=c50-zero
              y50x=(y51+y52)/2.
              w50=abs(x52-x51)

              yy1=xx1*sc+y0+y20
              yy2=xx2*sc+y0+y20

              call pgqci(ici)
              call pgsci(3)
              call pgmove(xx1,yy1)
              call pgdraw(xx2,yy2)
              call pgsci(ici)

              write(text,'(''Mark left and right 20% cuts.'')')
              call statusline(text,6,frame,0)
              call fullcursor(x21,y1,frame)
              call fullcursor(x22,y2,frame)

              if(x22.lt.x21)then
                 xx21=x21
                 x21=x22
                 x22=xx21
              endif

              c20=(x21+x22)/2.
              if(izero.eq.0)c20=c20-zero
              y20x=(y21+y22)/2.
              w20=abs(x22-x21)

              call profplot(ycont,xx,npix,cpeak,ypeak,c80,w80,
     +             c50,w50,c20,w20,czero,wzero)
              write(text,'('' C80='',f7.2,2x,''C50='',f7.2,2x,
     +             ''FWHM='',f6.2)')C80,C50,W50
              call statusline(text,6,frame,0)

           endif

        else
           write(*,'('' Peak not found.'')')
        endif
          
        return
        end

**************************************************************************

        subroutine gaussplot(nc,xx,zero,ycont,gpar,idg,imin,imax)

        common /options/izero,ireplot,imark,iyscaley,iyscalez,
     +     iprint,ihisto,icont
        common/gfit/xxx(4096),yyy(4096),yc(4096),nfit,ng

        real xx(4096),xxz(4096),yyz(4096)
        real xg(500),yg(500),ycont(4096), gpar(9,3)
        real par(3), param(27)
        integer idg(9)

        nfit=imax-imin+1
        do i=imin,imax
           j=i-imin+1
           xxx(j)=xx(i)
           if(izero.eq.0)xxx(j)=xxx(j)-zero
           yc(j)=ycont(i)
        enddo

        npar=0
        ng=0
        do i=1,3
           do j=1,nc
              j1=idg(j)
              if(gpar(j1,1).ne.0.0)then
                 if(i.eq.1)ng=ng+1
                 npar=npar+1
                 param(npar)=gpar(j1,i)
              endif
           enddo
        enddo

        do j=1,nc
           j1=idg(j)
           if(gpar(j1,1).ne.0.0)then
              do i=1,3
                 par(i)=gpar(j1,i)
              enddo
              xminp=par(1)-3.0*par(2)
              xmaxp=par(1)+3.0*par(2)
              if(xmaxp.eq.xminp)then
                 xmaxp=xmaxp+2.
                 xminp=xminp-2.
              endif
              call gauss1(par,yyz)
              ii=0
              do i=1,nfit
                 test=(xxx(i)-xminp)*(xxx(i)-xmaxp)
                 if(test.le.0.0)then
                    ii=ii+1
                    yg(ii)=yyz(i)+yc(i)
                    xg(ii)=xxx(i)
                    if(izero.eq.0)xg(ii)=xg(ii)+zero
                 endif
              enddo
           
              call pgqci(ici)
              call pgsci(8)
              call pgline(ii,xg,yg)
              call pgsci(ici)
           endif
        enddo
        
C     Plot combined fit.
        call amgauss(param,yyz)
        do i=1,nfit
           yyz(i)=yyz(i)+yc(i)
           xxz(i)=xxx(i)
           if(izero.eq.0)xxz(i)=xxz(i)+zero
        enddo
        
        call pgqci(ici)
        call pgsci(3)
        if(ihisto.eq.0)then
           call pgline(nfit,xxz,yyz)
        else
           call pgbin(nfit,xxz,yyz,.true.)
        endif
        call pgsci(ici)
        
        return
        end

*************************************************************************
      
      subroutine profplot(ycont,xx,npix,cpeak,ypeak,c80,w80,
     +     c50,w50,c20,w20,czero,wzero)
      
      common /gwindow/xmaxy,xminy,ymaxy,yminy,xmaxz,xminz,ymaxz,yminz
      common /gwindow2/yzero,zzero,xwindow,nslpix,nempix
      common /gwindow3/xleft,xright,ytop,ybot,ylen,xlen,xrange,yrange
      common /options/izero,ireplot,imark,iyscaley,iyscalez,
     +     iprint,ihisto,icont
      
      real ycont(4096),xx(4096)
      integer frame
            
      if(ytop.gt.0.6)then
         frame=1
         xmin=xminy
         xmax=xmaxy
         zero=yzero
      else
         frame=2
         xmin=xminz
         xmax=xmaxz
         zero=zzero
      endif

      cpeakx=cpeak
      if(izero.eq.0)cpeakx=cpeakx+zero
      c80x=c80
      if(izero.eq.0)c80x=c80x+zero
      c50x=c50
      if(izero.eq.0)c50x=c50x+zero
      c20x=c20
      if(izero.eq.0)c20x=c20x+zero
      czerox=czero
      if(izero.eq.0)czerox=czerox+zero

      do i=2,npix
         if(xx(i).ge.xmin.and.xx(i).le.xmax)then
            test1=(xx(i)-cpeakx)
            test2=(xx(i-1)-cpeakx)
            if(test1*test2.le.0.0)then
               ipeak=i
               if(abs(test2).lt.abs(test1))ipeak=i-1
            endif
         endif
      enddo
      j2=ipeak+20
      j1=ipeak-20
      if(j1.le.0)j1=1
      if(j2.gt.4096)j2=4096
      
      sc=(ycont(j2)-ycont(j1))/(xx(j2)-xx(j1))
      y0=ycont(j1)-sc*xx(j1)
      
      x81=c80x-w80/2.0
      x82=c80x+w80/2.0
      y81=x81*sc+y0+ypeak*0.8
      y82=x82*sc+y0+ypeak*0.8
      y80x=(y81+y82)/2.
      
      x51=c50x-w50/2.0
      x52=c50x+w50/2.0
      y51=x51*sc+y0+ypeak*0.5
      y52=x52*sc+y0+ypeak*0.5
      y50x=(y51+y52)/2.
      
      x21=c20x-w20/2.0
      x22=c20x+w20/2.0
      y21=x21*sc+y0+ypeak*0.2
      y22=x22*sc+y0+ypeak*0.2
      y20x=(y21+y22)/2.
      
      x01=czerox-wzero/2.0
      x02=czerox+wzero/2.0
      y01=x01*sc+y0
      y02=x02*sc+y0
      y00x=(y01+y02)/2.
      
      call pgqci(ici)
      call pgsci(5)
      
      call pgmove(x81,y81)
      call pgdraw(x82,y82)
      call pgpt(1,c80x,y80x,2)
      
      call pgmove(x51,y51)
      call pgdraw(x52,y52)
      call pgpt(1,c50x,y50x,2)
      
      call pgmove(x21,y21)
      call pgdraw(x22,y22)
      call pgpt(1,c20x,y20x,2)
      
      call pgmove(x01,y01)
      call pgdraw(x02,y02)
      call pgpt(1,czerox,y00x,2)
      
      call pgsci(ici)
      
      return
      end

******************************************************************************

        subroutine statusline(text,ici,frame,initial)

        character text*80, text1*80, text2*80, text3*80
        integer frame

        if(initial.eq.1)then
           text2='             '
           text3='             '
           return
        endif

        call pgqci(jci)
        call pgqch(ch)
        call pgsch(0.85)
        call pgsci(0)
        if(frame.eq.1)then
           call pgmtxt('B',2.5,0.5,0.5,text2)
           if(text.eq.'XXXXX')then
              text1=text2
           else
              text1=text
              text2=text
           endif
        else
           call pgmtxt('B',2.5,0.5,0.5,text3)
           if(text.eq.'XXXXX')then
              text1=text3
           else
              text1=text
              text3=text
           endif
        endif

        call pgsci(ici)
        call pgmtxt('B',2.5,0.5,0.5,text1)
        call pgsci(jci)
        call pgsch(ch)

        return
        end

*****************************************************************************

      subroutine results(iunit)

      common /gwindow2/yzero,zzero,xwindow,nslpix,nempix
      common /centers/slc(9),sly(9),idslc(9),nslc,
     +     emc(9),emy(9),idemc(9),nemc
      common /gaussians/slgpar(9,3),islmin(10),islmax(10),nslgfit,
     +     emgpar(9,3),iemmin(10),iemmax(10),nemgfit
      common /profiles/slcpeak(9),slpeak(9),slc80(9),slw80(9),slc50(9),
     +     slw50(9),slc20(9),slw20(9),slczero(9),slwzero(9),slflux(9),
     +     emcpeak(9),empeak(9),emc80(9),emw80(9),emc50(9),emw50(9),
     +     emc20(9),emw20(9),emczero(9),emwzero(9),emflux(9)
      common /results1/yres1,yres2,zres1,zres2,logfile
      common /spect/disp, lambda0

      real lambda0
      character logfile*80,yres1*80,yres2*80,zres1*80,zres2*80
      character text1*31, text2*29, text3*20

      ccc=299792.5
      if(iunit.ne.6)then
         open(unit=iunit,file=logfile,status='unknown',
     +        access='append')
      endif

      write(iunit,'(a)')yres1
      write(iunit,'(a)')yres2
      write(iunit,'(a)')zres1
      write(iunit,'(a)')zres2
      write(iunit,'('' Rest Wavelength: '',f8.2,'' --- Dispersion: '',
     +     f6.3)')lambda0,disp

      write(iunit,'(''-------------------------------------------'',
     +     ''-'')')
      write(iunit,'(''         Centers           shift    '',
     +     ''velocity'')')
      write(iunit,'('' #  Slitless   Em.Line      Ang.      '',
     +     ''km/s '')')
      write(iunit,'(''-------------------------------------------'',
     +     ''-'')')
      do i=1,nslc
         if(sly(i).ne.0.0.and.emy(i).ne.0.0)then
            dlambda=disp*(slc(i)-emc(i))
            dvel=ccc*dlambda/(lambda0)
            write(iunit,'(x,i1,4x,f6.2,4x,f6.2,4x,f6.2,4x,i6)')
     +           i,slc(i),emc(i),dlambda,nint(dvel)
         else if(sly(i).ne.0.0.and.emy(i).eq.0.0)then
            write(iunit,'(x,i1,4x,f6.2,7x,''---'',
     +           7x,''---'',7x,''---'')')i,slc(i)
         else if(sly(i).eq.0.0.and.emy(i).ne.0.0)then
            write(iunit,'(x,i1,7x,''---'',4x,f6.2,
     +           7x,''---'',7x,''---'')')i,emc(i)
         endif
      enddo
      
      write(iunit,'(''------------------------------------------'',
     +     ''------------------------------------'')')
      write(iunit,'(''     Slitless Spect. Gaussians   '',
     +     ''Emiss. Line Image Gaussians   shift '',
     +     ''velocity'')')
      write(iunit,'('' #   Center   Sigma   Amplitude   '',
     +     ''Center   Sigma   Amplitude    Ang.   '',
     +     ''km/s'')')
      write(iunit,'(''------------------------------------------'',
     +     ''------------------------------------'')')
      do j=1,nslc
         ampvalue=slgpar(j,3)
         if(ampvalue.ge.100.0)then
            write(text1,'(x,i1,2x,f7.2,2x,f6.2,2x,i10)')
     +           j,(slgpar(j,k), k=1,2),nint(ampvalue)
         else if(ampvalue.lt.200.0.and.ampvalue.ge.0.2)then
            write(text1,'(x,i1,2x,f7.2,2x,f6.2,2x,f10.3)')
     +           j,(slgpar(j,k), k=1,3)
         else if(ampvalue.lt.0.2.and.ampvalue.ge.1.0e-5)then
            write(text1,'(x,i1,2x,f7.2,2x,f6.2,2x,f10.7)')
     +           j,(slgpar(j,k), k=1,3)
         else if(ampvalue.lt.1.0e-5.and.ampvalue.ne.0.0)then
            write(text1,'(x,i1,2x,f7.2,2x,f6.2,2x,1pe10.4)')
     +           j,(slgpar(j,k), k=1,3)
         else if(ampvalue.eq.0.0)then
            write(text1,'(x,i1,6x,''---'',5x,''---'',9x,
     +           ''---'')')j

         endif
         ampvalue=emgpar(j,3)
         if(ampvalue.ge.100.0)then
            write(text2,'(2x,f7.2,2x,f6.2,2x,i10)')
     +           (emgpar(j,k), k=1,2),nint(ampvalue)
         else if(ampvalue.lt.200.0.and.ampvalue.ge.0.2)then
            write(text2,'(2x,f7.2,2x,f6.2,2x,f10.3)')
     +           (emgpar(j,k), k=1,3)
         else if(ampvalue.lt.0.2.and.ampvalue.ge.1.0e-5)then
            write(text2,'(2x,f7.2,2x,f6.2,2x,f10.7)')
     +           (emgpar(j,k), k=1,3)
         else if(ampvalue.lt.1.0e-5.and.ampvalue.ne.0.0)then
            write(text2,'(2x,f7.2,2x,f6.2,2x,1pe10.4)')
     +           (emgpar(j,k), k=1,3)
         else if(ampvalue.eq.0.0)then
            write(text2,'(6x,''---'',5x,''---'',9x,''---'')')
         endif

         if(ampvalue.ne.0.0)then
            dlambda=disp*(slgpar(j,1)-emgpar(j,1))
            dvel=ccc*dlambda/(lambda0)
            write(text3,'(2x,f6.2,2x,i6)')dlambda,nint(dvel)
         else
            write(text3,'(5x,''---'',5x,''---'')')
         endif
         write(iunit,'(a31,a29,a20)')text1,text2,text3
      enddo

      write(iunit,'(''------------------------------------------'',
     +     ''--------------------------------------'')')

      write(iunit,'(33x,''Profile Analysis'')')
      write(iunit,'('' #    Flux  Cpeak     Peak    C80   W80    '',
     +     ''C50   W50    C20   W20    C00   W00'')')
      write(iunit,'(''------------------------------------------'',
     +     ''--------------------------------------'')')

      do i=1,nslc
         if(slflux(i).ge.1000.0)then
            write(iunit,'(''S'',i1,x,f8.0,x,f6.1,x,f8.0,
     +           4(x,f6.1,x,f5.1))')
     +           i,slflux(i),slcpeak(i),slpeak(i),slc80(i),
     +           slw80(i),slc50(i),slw50(i),slc20(i),slw20(i),
     +           slczero(i),slwzero(i)

         else if(slflux(i).lt.1000.0.and.slflux(i).ge.10.0)then
            write(iunit,'(''S'',i1,x,f8.3,x,f6.1,x,f8.3,
     +           4(x,f6.1,x,f5.1))')
     +           i,slflux(i),slcpeak(i),slpeak(i),slc80(i),
     +           slw80(i),slc50(i),slw50(i),slc20(i),slw20(i),
     +           slczero(i),slwzero(i)

         else if(slflux(i).lt.10.0.and.slflux(i).ge.0.001)then
            write(iunit,'(''S'',i1,x,f8.5,x,f6.1,x,f8.5,
     +           4(x,f6.1,x,f5.1))')
     +           i,slflux(i),slcpeak(i),slpeak(i),slc80(i),
     +           slw80(i),slc50(i),slw50(i),slc20(i),slw20(i),
     +           slczero(i),slwzero(i)

         else if(slflux(i).lt.0.001.and.slflux(i).gt.0.0)then
            write(iunit,'(''S'',i1,x,1pe8.2,x,0pf6.1,x,1pe8.2,
     +           4(x,0pf6.1,x,0pf5.1))')
     +           i,slflux(i),slcpeak(i),slpeak(i),slc80(i),
     +           slw80(i),slc50(i),slw50(i),slc20(i),slw20(i),
     +           slczero(i),slwzero(i)

         else
            write(iunit,'(''S'',i1,6x,''---'',4x,''---'',6x,''---'',
     +           4(4x,''---'',3x,''---''))')i
         endif
         if(emflux(i).ge.1000.0)then
            write(iunit,'(''E'',i1,x,f8.0,x,f6.1,x,f8.0,
     +           4(x,f6.1,x,f5.1))')
     +           i,emflux(i),emcpeak(i),empeak(i),emc80(i),
     +           emw80(i),emc50(i),emw50(i),emc20(i),emw20(i),
     +           emczero(i),emwzero(i)
         else if(emflux(i).lt.1000.0.and.emflux(i).ge.10.0)then
            write(iunit,'(''E'',i1,x,f8.3,x,f6.1,x,f8.3,
     +           4(x,f6.1,x,f5.1))')
     +           i,emflux(i),emcpeak(i),empeak(i),emc80(i),
     +           emw80(i),emc50(i),emw50(i),emc20(i),emw20(i),
     +           emczero(i),emwzero(i)
         else if(emflux(i).lt.10.0.and.emflux(i).ge.0.001)then
            write(iunit,'(''E'',i1,x,f8.5,x,f6.1,x,f8.5,
     +           4(x,f6.1,x,f5.1))')
     +           i,emflux(i),emcpeak(i),empeak(i),emc80(i),
     +           emw80(i),emc50(i),emw50(i),emc20(i),emw20(i),
     +           emczero(i),emwzero(i)
         else if(emflux(i).lt.0.001.and.emflux(i).gt.0.0)then
            write(iunit,'(''E'',i1,x,1pe8.2,x,0pf6.1,x,1pe8.2,
     +           4(x,0pf6.1,x,0pf5.1))')
     +           i,emflux(i),emcpeak(i),empeak(i),emc80(i),
     +           emw80(i),emc50(i),emw50(i),emc20(i),emw20(i),
     +           emczero(i),emwzero(i)
         else
            write(iunit,'(''E'',i1,6x,''---'',4x,''---'',6x,''---'',
     +           4(4x,''---'',3x,''---''))')i
         endif

         if(slflux(i).ne.0.0.and.emflux(i).ne.0.0)then
            vpeak=ccc*disp*(slcpeak(i)-emcpeak(i))/lambda0
            v80=ccc*disp*(slc80(i)-emc80(i))/lambda0
            v50=ccc*disp*(slc50(i)-emc50(i))/lambda0
            v20=ccc*disp*(slc20(i)-emc20(i))/lambda0
            vzero=ccc*disp*(slczero(i)-emczero(i))/lambda0

            if(slw80(i).gt.emw80(i))then
               w80=sqrt(slw80(i)*slw80(i)-emw80(i)*emw80(i))
            else
               w80=0.0
            endif
            w80=ccc*disp*(w80)/lambda0

            if(slw50(i).gt.emw50(i))then
               w50=sqrt(slw50(i)*slw50(i)-emw50(i)*emw50(i))
            else
               w50=0.0
            endif
            w50=ccc*disp*(w50)/lambda0

            if(slw20(i).gt.emw20(i))then
               w20=sqrt(slw20(i)*slw20(i)-emw20(i)*emw20(i))
            else
               w20=0.0
            endif
            w20=ccc*disp*(w20)/lambda0

            if(slwzero(i).gt.emwzero(i))then
               wzero=sqrt(slwzero(i)*slwzero(i)-emwzero(i)*emwzero(i))
            else
               wzero=0.0
            endif
            wzero=ccc*disp*(wzero)/lambda0

            write(iunit,'(''V'',i1,10x,f6.1,9x,4(x,f6.1,x,f5.1))')
     +           i,vpeak,v80,w80,v50,w50,v20,w20,vzero,wzero

         else
            write(iunit,'(''V'',i1,13x,''---'',9x
     +           4(4x,''---'',3x,''---''))')i
            
         endif
      enddo
      write(iunit,'(''------------------------------------------'',
     +     ''--------------------------------------'')')
      if(iunit.ne.6)then
         close(iunit)
      endif

      return
      end
      
****************************************************************************

      subroutine load(xxx,image,ix1,ix2,iy1,iy2)

      CHARACTER IMAGE*50,errmsg*80
      INTEGER axlen(7)
      dimension xxx(2048,2048),yyy(2048)
      
      if(image.eq.'unknown')then
         write(*,'('' Type name of IRAF image: '',$)')
         read(*,'(a)')image
      endif
      
C  OPEN IRAF IMAGE.

      call imopen(image, 1, im1, ier)
      if (ier .ne. 0) goto 99

      call imgsiz (im1, axlen, NDIM, dtype, ier)
      if (ier .ne. 0) goto 99

      nx=axlen(1)
      ny=axlen(2)

      if(ix1.eq.0.and.ix2.eq.0)then
         ix1=1
         ix2=nx
      endif
      if(iy1.eq.0.and.iy2.eq.0)then
         iy1=1
         iy2=ny
      endif

      jx1=1
      jx2=nx
      jy1=1
      jy2=ny

      do jy=1,ny
         if(jy.ge.jy1.and.jy.le.jy2)then
            call imgl2r(im1, yyy, jy, ier)
            if (ier .ne. 0) goto 99
            do jx=1,nx
               if(jx.ge.jx1.and.jx.le.jx2)then
                  xxx(jx,jy)=yyy(jx)
               else
                  xxx(jx,jy)=0.0
               endif
            enddo
         else
            do jx=1,nx
               xxx(jx,jy)=0.0
            enddo
         endif
      enddo

C      call imgs2r(im1, xxx, ix1, ix2, iy1, iy2, ier)
C      if (ier .ne. 0) goto 99

      call imclos (im1, ier)
      if (ier .eq. 0) goto 100

C       Error messages written to terminal.

 99   call imemsg(ier, errmsg)
      write(*,*) 'ERROR: ', errmsg
 100  return
      end
      
******************************************************************************

      function istrlen(string, maxlen)

      character string*(*)
      
      j=0
      do i=1,maxlen
         if(string(i:i).eq.' ')then
            if(j.eq.0) j=i
         else
            j=0
         endif
      enddo
      istrlen=j-1
      return
      end

      




